#ifndef _PDBFont_H_
#define _PDBFont_H_

#include <wolf.h>
#include "list.h"

#define FONT_CASH_SIZE 20000

struct PDB_symbol
{
    unsigned int offset;
    char top_skip;
    char left_skip;
    char advance;
    unsigned short int width;
    unsigned short int height;
    unsigned short int rawbyte;
    unsigned short int size;
    unsigned char *bytes;
};

struct PDB_Font
{
    int fontFile;
    unsigned char name[32];
    unsigned char size;
    unsigned char ital;
    unsigned char bold;
    char height;
    char ascent;
    char leading;
    char enc;
    struct PDB_symbol symbol[224];
};

struct PDB_Font *InitPDBfont(unsigned char *file, unsigned char gamma_idx);
struct PDB_Font *ClosePDBfont(struct PDB_Font *font);
unsigned short int PrintChar(int win, int x, int y, unsigned char symb, struct PDB_Font *PDBfont, unsigned char operation);
void Print(int win, int x, int y, unsigned char *text, struct PDB_Font *PDBfont);
unsigned short int GetCharWidth(unsigned char c, struct PDB_Font *PDBfont);
unsigned short int GetCharHeight(unsigned char c, struct PDB_Font *PDBfont);
unsigned int GetStringWidth(unsigned char *text, struct PDB_Font *PDBfont);
unsigned short int GetFontHeight(struct PDB_Font *PDBfont);
short int GetFontAscent(struct PDB_Font *PDBfont);

#endif
