#include "er.h"
#include "actions.h"
#include "messages.h"
#include "all_extern.h"

// --- some functions
void InitArea ();

void Do_Press(unsigned char key)
{
    switch (key)
    {
    case aFREE:
        break;
    case aNEXT_PAGE:
        if (page[curr_page].end<=fd_size)
        {
            save_progress--;
            TurnNextPage();
            PaintPage(curr_page);
            allow_prev_page = 1;
        }
        break;
    case aPREV_PAGE:
        if ((page[curr_page].start>0)&&(allow_prev_page))
        {
            save_progress--;
            TurnPrevPage();
            PaintPage(curr_page);
        }
        break;
    case aNEXT_10PAGES:
        page[curr_page].end = page[curr_page].start + 10*(stat->byte.read_byte/stat->byte.read_counter);
        if (page[curr_page].end > fd_size) page[curr_page].end = fd_size - 100;
        LoadNextPage();
        TurnNextPage();
        PaintPage(curr_page);
        allow_prev_page = 0;
        break;
    case aPREV_10PAGES:
        page[curr_page].end = page[curr_page].start - 10*(stat->byte.read_byte/stat->byte.read_counter);
        if (page[curr_page].end < 0) page[curr_page].end = 0;
        LoadNextPage();
        TurnNextPage();
        PaintPage(curr_page);
        allow_prev_page = 0;
        break;
    case aNEXT_PROC:
        page[curr_page].end = page[curr_page].start + fd_size/100;
        if (page[curr_page].end > fd_size) page[curr_page].end = fd_size - 100;
        LoadNextPage();
        TurnNextPage();
        PaintPage(curr_page);
        allow_prev_page = 0;
        break;
    case aPREV_PROC:
        page[curr_page].end = page[curr_page].start - fd_size/100;
        if (page[curr_page].end < 0) page[curr_page].end = 0;
        LoadNextPage();
        TurnNextPage();
        PaintPage(curr_page);
        allow_prev_page = 0;
        break;
    case aGOTO_PROC:
        dialog.id = 77;
        ShowDialog(page[curr_page].start*100/fd_size, 0, 0, 100, 1, 2, txt.go_to);
        allow_prev_page = 0;
        break;
    case aGOTO_PAGE:
        dialog.id = 78;
        ShowDialog(page[curr_page].start/(stat->byte.read_byte/stat->byte.read_counter), 0, 0, 
                  fd_size/(stat->byte.read_byte/stat->byte.read_counter), 1, 2, txt.go_to_page);
        allow_prev_page = 0;
        break;
    case aROTATE:
        opt.page.layout++;
        if (opt.page.layout==4) opt.page.layout = 0;
        config_changed = 1;
        ReDraw();
        break;
    case aPROFILE:
        opt.profile_no = 1-opt.profile_no;
        config_resetStat = 1;
        config_changed = 1;
        ReDraw();
        break;
    case aFULL_SCR:
        opt.page.fullscr = 1-opt.page.fullscr;
        config_changed = 1;
        ReDraw();
        break;
    case aBKMARK_SET:
        if (bkmrk_count==64) 
        {
            Alert(txt.nomore_bookmarks,1,1);
        }
        else
        {
            AddBookMark();
            ReDraw();// Just to show that something has happend
        }
        break;
    case aBKMARK_NEXT:
        bkmrk_curr++;
        if (bkmrk_curr>=bkmrk_count) bkmrk_curr = 0;
        bkmrk_goto = 1;
        ReDraw();
        break;
    case aBKMARK_PREV:
        bkmrk_curr--;
        if (bkmrk_curr>=64) bkmrk_curr = bkmrk_count-1;
        bkmrk_goto = 1;
        ReDraw();
        break;
    case aBKMARK_SHOW:
        if (bkmrk_count==0) 
        {
            Alert(txt.show_bookmarks,1,1);
        }
        else
        {
            OpenScreen(0, BookMark_Handler, "BookMarks", 7014);
        }
        break;
    case aGOTO_FIRST:
        page[curr_page].end = 0;
        LoadNextPage();
        TurnNextPage();
        PaintPage(curr_page);
        allow_prev_page = 0;
        break;
    case aGOTO_LAST:
        page[curr_page].end = fd_size - 100;
        LoadNextPage();
        TurnNextPage();
        PaintPage(curr_page);
        allow_prev_page = 0;
        break;
    case aREFRESH:
        ReDraw();        
        break;
    case aRETURN:
        page[curr_page].end = prev_pos;
        LoadNextPage();
        TurnNextPage();
        PaintPage(curr_page);
        allow_prev_page = 0;
        break;
    case aLOCK:
        OpenScreen(0, Lock_Handler, "Lock", 7015);
        break;
    }
}

void Do_Release(unsigned char key)
{
    switch (key)
    {
    case aFREE:
        break;
    case aNEXT_PAGE:
        if (page[curr_page].end<fd_size) LoadNextPage();
        break;
    case aPREV_PAGE:
        break;
    case aNEXT_10PAGES:
        LoadNextPage();
        break;
    case aPREV_10PAGES:
        LoadNextPage();
        break;
    case aNEXT_PROC:
        LoadNextPage();
        break;
    case aPREV_PROC:
        LoadNextPage();
        break;
    case aGOTO_PROC:
        break;
    case aROTATE:
        SaveOptions();
        break;
    case aPROFILE:
        SaveOptions();
        break;
    case aFULL_SCR:
        SaveOptions();
        break;
    case aBKMARK_SET:
        SaveBookMarks();    
        break;
    case aBKMARK_NEXT:
        break;
    case aBKMARK_PREV:
        break;
    case aBKMARK_SHOW:
        break;
    case aGOTO_FIRST:
        LoadNextPage();
        break;
    case aGOTO_LAST:
        LoadNextPage();
        break;
    case aREFRESH:
        LoadNextPage();
        break;
    case aRETURN:
        LoadNextPage();
        break;
    }
}
