#include "er.h"
#include "cfg_common.h"
#include "messages.h"

unsigned char mrkpage, mpage, mrkcount, mtop, mdel;
unsigned char mrk_long_press;

void LoadBookMarks()
{
    bkmrk_count = 0;   
    bkmrk_curr = 0;
    bkmrk_goto = 0;    

    int bkmrk_file, size, i;

    bkmrk_file = OpenFile(bkmrk_filename);
    if (bkmrk_file==0) return;

    ReadFile(bkmrk_file, &bkmrk_count, 1, &size);

    for (i=0;i<bkmrk_count;i++)
    {
        bookmark[i] = calloc(sizeof(struct bookmarks));
        
        ReadFile(bkmrk_file, bookmark[i], sizeof(struct bookmarks), &size);    
    }
    
    CloseFile(bkmrk_file);
}

void SaveBookMarks()
{
    int bkmrk_file, size, i;

    DeleteFile(bkmrk_filename);
    bkmrk_file = CreateFile(bkmrk_filename);
    if (bkmrk_file==0) return;

    WriteFile(bkmrk_file, &bkmrk_count, 1, &size);

    for (i=0;i<bkmrk_count;i++)
    {
        WriteFile(bkmrk_file, bookmark[i], sizeof(struct bookmarks), &size);
    }
    
    CloseFile(bkmrk_file);
}

void AddBookMark()
{
    long int cur_pos;
    cur_pos = page[curr_page].start;
    
    int i, offset=0;
    unsigned char unique=1;
    // check if there is such bookmark already
    for (i=0;i<bkmrk_count;i++)
    {
        if (bookmark[i]->pos==cur_pos) 
        {
            unique=0;
            break;
        }
    }
    
    // needed for bookmark's sorting
    struct bookmarks *bookmark_tmp;
    
    // if there is no such bookmark
    if (unique)
    {
        bookmark[bkmrk_count] = calloc(sizeof(struct bookmarks));
        
        bookmark[bkmrk_count]->pos=cur_pos;
        for (i=0;i<(page[curr_page].end-99);i++)
        {
            if (((data + curr_page*BUFF_SIZE + i)->symb)==0) 
            {
                offset = i+1;
                break;
            }
        }
        for (i=0;i<99;i++)        
        {
            bookmark[bkmrk_count]->note[i] = (data + curr_page*BUFF_SIZE + offset + i)->symb;
            if (bookmark[bkmrk_count]->note[i]<32) bookmark[bkmrk_count]->note[i] = 32;          
        }
        bookmark[bkmrk_count]->note[99] = 0;
        bkmrk_count++;
        
        for (i=bkmrk_count-1;i>0;i--)
        {
            if (bookmark[i]->pos < bookmark[i-1]->pos)
            {
                bookmark_tmp = bookmark[i-1];
                bookmark[i-1] = bookmark[i];
                bookmark[i] = bookmark_tmp;
            }
        }
    }
}

void DeleteBookMark(int i)
{
    free(bookmark[i]);
    bookmark[i] = NULL;
    
    int j;
    for (j=i;j<bkmrk_count;j++)
    {
        bookmark[j]=bookmark[j+1];
    }
    bkmrk_count--;
}

void FreeBookMarks()
{
    int i;
    for (i=0;i<bkmrk_count;i++)
    {
        free(bookmark[i]);
        bookmark[i] = NULL;
    }
}

void BookMark_DrawTop(int p) 
{
    char buf[256];

    SetCurrFont(sysFont); 

    DrawImageResource(EINK, 0, 0, "CONF_TOP");
    if (opt_new.lang == 0) DrawImageResource(EINK, 8, 8, "CONF_BAN_BKMRK_EN");
    if (opt_new.lang == 1) DrawImageResource(EINK, 8, 8, "CONF_BAN_BKMRK_RU");

    int x = 12;
    int y = 36;
    int tw0 = 56;  
    int tw1 = 184;
    int th0 = 40;  
    int th1 = 44;

    if (p == 1) 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    } 
    else 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "1");
        x += tw0;
    }

    if (mrkpage>=2) 
    {
        if (p == 2) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "2");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "2");
            x += tw0;
        }
    }

    if (mrkpage>=3) 
    {
        if (p == 3) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "3");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "3");
            x += tw0;
        }
    }

    if (mrkpage>=4) 
    {
        if (p == 4) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "4");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "4");
            x += tw0;
        }
    }

    if (mrkpage>=5) 
    {
        if (p == 5) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "5");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "5");
            x += tw0;
        }
    }

    if (mrkpage>=6) 
    {
        if (p == 6) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "6");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "6");
            x += tw0;
        }
    }

    if (mrkpage>=7) 
    {
        if (p == 7) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "7");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "7");
            x += tw0;
        }
    }

    if (mrkpage>=8) 
    {
        if (p == 8) 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "8");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        } 
        else 
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "8");
            x += tw0;
        }
    }
}

void BookMark_Paint() 
{
    int i, offset;
    char buf[50];
    int prgrs_1=0, prgrs_2=0, pg_smbl;
    long int proc_xx, proc_y; // xx.yy
    pg_smbl = stat->byte.read_byte/stat->byte.read_counter;
    proc_xx = fd_size/100;
    if (proc_xx == 0) proc_xx = 1;
    proc_y = fd_size/10000;
    if (proc_y == 0) proc_y = 1;

    ClearWindow(EINK);
    SetCurrFont(2); 

    mrkcount = bkmrk_count;    
    mrkpage = mrkcount/8+1;  
    if (mrkpage>8) mrkpage = 8;

    BookMark_DrawTop(mpage);

    for (i=mtop; i<(mtop+8); i++) 
    {
        if (i < mrkcount) 
        {
            DrawCase(i-mtop+1, 1, 3, "");

            prgrs_1 = bookmark[i]->pos/proc_xx;
            prgrs_2 = (bookmark[i]->pos - prgrs_1*proc_xx)/proc_y;
            
            memset(&buf, 0, 50);
            sprintf(buf, "%s %i (%i.%-02i%%)", txt.cfg_page4_title, bookmark[i]->pos/pg_smbl, prgrs_1, prgrs_2);
            
            SetCurrFont(3);
            TextOutCenter(EINK, 60, (i-mtop+1)*80+4, 540, 40, 1, 1, buf);
            SetCurrFont(2);
            offset = TextOutMultiLines(EINK, 60, (i-mtop+1)*80+28, 540, bookmark[i]->note, 0);
            offset = TextOutMultiLines(EINK, 60, (i-mtop+1)*80+52, 540, bookmark[i]->note+offset, 1);
        }
        else 
        {
            DrawCase(i-mtop+1, 1, 0, "");
        }
    }  
    DrawBot(0, 0, 0, 0, txt.dialog_Cancel);
}

int BookMark_Init(struct event *e) 
{
    if ((opt.page.layout==1)||(opt.page.layout==3)) SetLayout(EINK, 0);

    mtop = 0;
    mpage = 1;
    
    mrk_long_press=0;    
    mdel = 1;
    return 0;
}

int BookMark_Exit(struct event *e) 
{
    return 0;
}

int BookMark_Show(struct event *e) 
{
    BookMark_Paint();
    return 0;
}

int BookMark_KeyPress(struct event *e) 
{
    mrk_long_press=0;
    int key = e->par1;

    switch (key) 
    {
    case KEY_PREV:
        mpage--;
        if (mpage==0) mpage = mrkpage;
        mtop = (mpage-1)*8;
        BookMark_Paint();        
        break;
    case KEY_NEXT:
        mpage++;
        if (mpage>mrkpage) mpage = 1;
        mtop = (mpage-1)*8;
        BookMark_Paint();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        CloseScreen();
        break;
    }
    return 0;
}

int BookMark_KeyRelease(struct event *e) 
{
    mdel = 1;
    if (mrk_long_press) return 0;
    int key = e->par1;

    if ((key>0x30)&&(key<0x39)&&((key-0x31+mtop)<mrkcount)) 
    {
        bkmrk_curr = (key-0x31)+mtop;
        bkmrk_goto = 1;
        CloseScreen();
    }
    return 0;
}

int BookMark_KeyRepeat(struct event *e) 
{
    mrk_long_press=1;
    
    int key = e->par1;
    if ((key>0x30)&&(key<0x39)&&((key-0x31+mtop)<mrkcount)&&(mdel)) 
    {
        mdel = 0;
        DeleteBookMark((key-0x31)+mtop);
        SaveBookMarks();
        if (bkmrk_count==0) CloseScreen();
        BookMark_Paint();        
    }
    return 0;
}

static const struct evtproc bookMark_evtproc[] = 
{
    { EVT_INIT, BookMark_Init },
    { EVT_SHOW, BookMark_Show },
    { EVT_KEYPRESS, BookMark_KeyPress },
    { EVT_KEYRELEASE, BookMark_KeyRelease },
    { EVT_KEYREPEAT, BookMark_KeyRepeat },
    { EVT_EXIT, BookMark_Exit },
    { 0,    NULL },
};

void BookMark_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(bookMark_evtproc, &evt);
    TranslateEvent(&evt);
}
