#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void Help_DrawTop(unsigned char p) 
{
    SetCurrFont(sysFont); 

    DrawImageResource(EINK, 0, 0, "CONF_TOP");
    if (opt_new.lang == 0) DrawImageResource(EINK, 8, 8, "CONF_BAN_HELP_EN");
    if (opt_new.lang == 1) DrawImageResource(EINK, 8, 8, "CONF_BAN_HELP_RU");

    int x = 12;
    int y = 36;
    int tw0 = 56;  
    int tw1 = 184;
    int th0 = 40;  
    int th1 = 44;

    if (p == 1) 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, txt.help_page1_1);
        x += tw1;
    }
    else 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, txt.help_page1_0);
        x += tw0;
    }

    if (p == 2) 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, txt.help_page2_1);
        x += tw1;
    }
    else 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, txt.help_page2_0);
        x += tw0;
    }

    if (p == 3) 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, txt.help_page3_1);
        x += tw1;
    }
    else 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, txt.help_page3_0);
        x += tw0;
    }

    if (p == 4) 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, txt.help_page4_1);
        x += tw1;
    }
    else 
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, txt.help_page4_0);
        x += tw0;
    }
}

void Help_Paint() 
{
    int x = 40;
    int y = 100;
    int h = 28;  
    int tw = 560;  
    int th = 40;  
    char buf[7];

    ClearWindow(EINK);

    Help_DrawTop(help_page);
    DrawCase(1, 1, 0, "");
    DrawCase(2, 1, 0, "");
    DrawCase(3, 1, 0, "");
    DrawCase(4, 1, 0, "");
    DrawCase(5, 1, 0, "");
    DrawCase(6, 1, 0, "");
    DrawCase(7, 1, 0, "");
    DrawCase(8, 1, 0, "");
    DrawBot(txt.dialog_Ok, 0, 0, 0, 0);

    FillArea(EINK, 20, 80, 560, 640, 3, AND);
    
    SetCurrFont(2); 
    switch(help_page) 
    {
    case 1: 
        DrawImageResource(EINK, 72, 80, "ABOUT");
        x = 60;
        y = 300;
        h = 20;  
        if (opt_new.lang==1) 
        {
            sprintf(buf, "v.0.%-03i", opt_new.version);
            TextOutCenter(EINK, 0, y, 600, th, 0, 0, buf);
            y+=h;
            TextOutCenter(EINK, 0, y, 600, th, 0, 0, "2007-2008, Ice (aka  )");
            y+=2*h;
            
            SetCurrFont(1); 
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  ,     ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  .  -   ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "GNU General Public License  Free Software Foundation.");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    \" \".   ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    ,   ,");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  ,      ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "   ,     .");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "http://www.gnu.org/copyleft/gpl.html");
            DrawHLine(EINK, x, y+26, 290, 1);
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "http://sourceforge.net/projects/ezhik-reader/");
            DrawHLine(EINK, x, y+26, 360, 1);
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  ,       ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    http://www.the-ebook.org/forum");
            DrawHLine(EINK, x+160, y+26, 240, 1);
        } 
        else 
        { 
            //i.e. if not Russian - then English
            sprintf(buf, "v.0.%-03i", opt_new.version);
            TextOutCenter(EINK, 0, y, 600, th, 0, 0, buf);
            y+=h;
            TextOutCenter(EINK, 0, y, 600, th, 0, 0, "2007-2008, Ice (aka Evgeny Kalabin)");
            y+=2*h;
            
            SetCurrFont(1); 
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "This programm is free software; you can redistribute it and/or");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "modify it under the terms of the GNU General Public");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "License as published by the Free Software Foundation.");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "This programm is distributed in the hope that it will be useful,");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "but WITHOUT ANY WARRANTY; without even the implied warranty of");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "General Public License for more details:");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "http://www.gnu.org/copyleft/gpl.html");
            DrawHLine(EINK, x, y+26, 290, 1);
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "The sources are available at ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "http://sourceforge.net/projects/ezhik-reader/");
            DrawHLine(EINK, x, y+26, 360, 1);
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "You can contact me and/or to get to know a lot about e-reading");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "at the best forum regarding this topic:");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "http://www.the-ebook.org/forum (unfortunately in Russian only)");
            DrawHLine(EINK, x, y+26, 240, 1);
            y+=h;
        }
        break;
    case 2: 
        if (opt_new.lang==1) 
        {
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      .");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"0\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"1\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\" 1\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"2\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"3\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"4\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"5\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"6\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"7\", \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"8\", \"A\", \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"9\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "       :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"B\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"C\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      N- %:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"D\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      N- :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, " \"D\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"E\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      10 . Ш:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, " \"|>\"");
            y+=h; 
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      10 . :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, " \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "       :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"ESC\"");
            y+=h;
        } 
        else 
        { 
            //i.e. if not Russian - then English
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "All the buttons can be reassigned. Below");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "you can see only standard values.");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    OPTIONS:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"0\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    SET BOOKMARK:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"1\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    SHOW ALL BOOKMARKS:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"long 1\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    GOTO PREV.BOOKMARK:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"2\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    GOTO NEXT BOOKMARK:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"3\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    RETURN:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"4\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    MOVE TO FIRST PAGE:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"5\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    MOVE TO LAST PAGE:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"6\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    PREVIOUS PAGE:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"7\", \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    NEXT PAGE:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"8\", \"A\", \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    LOCK KEYS:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"9\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    FULLSCREEN:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"B\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    CHANGE PROFILE:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"C\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    MOVE TO N%:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"D\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    MOVE TO PAGE #N:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "long \"D\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    ROTATE SCREEN:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"E\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    MOVE 10 PAGES FORWARD:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "long \"|>\"");
            y+=h; 
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    MOVE 10 PAGES BACKWARD:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "long \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    EXIT TO BOOKSHELF:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"ESC\"");
            y+=h;
        }
        break;
    case 3: 
        if (opt_new.lang==1) 
        {
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  ,  ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  ,    ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "(.    ).");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, ",      ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "( \" \", \"\"). ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, ".");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    :");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"0\"-\"9\"   ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"A\", \"B\", \"C\", \"D\", \"E\"  ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"<|>\"  \"ESC\"   ");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  :");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :            \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :          \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :                \"A\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :                  \"\", \"ESC\"");
            y+=h;      
        } 
        else 
        { 
            //i.e. if not Russian - then English
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "The different parameters are configured by");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "pressing the corresponding digital button at the");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "left. The values will be changed immediately, or");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "the dialog will be started (see the next tab for");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "the dialogs description).");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "The font and paragraph parameters are groupped");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "into two profiles, each of them has also several");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "styles (such as \"regular text\", \"header\").");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "Styles are configured for each profile separately.");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "There are the following buttons we have:");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"0\"-\"9\" at the left");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"A\", \"B\", \"C\", \"D\" and \"E\" below the screen");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"<|>\" and \"ESC\" at the right");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "There is the following key-mapping at the moment:");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    NEXT TAB:                              \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    PREVIOUS TAB:                     \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    SAVE AND EXIT:                    \"A\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    CANCEL AND EXIT:                \"\", \"ESC\"");
            y+=h;      
        }
        break;
    case 4: 
        if (opt_new.lang==1) 
        {
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  / - .");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    ,  ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, " .");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    :");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"0\"-\"9\"   ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"A\", \"B\", \"C\", \"D\", \"E\"  ");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"<|>\"  \"ESC\"   ");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "  :");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "     :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"0\"-\"9\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "       X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"D\", \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      10*X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, " \"D\", \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "       X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"B\", \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      10*X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, " \"B\", \"<|\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "      :");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"C\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    /:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"A\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    /:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"\", \"ESC\"");
            y+=h;              
        } 
        else 
        { 
            //i.e. if not Russian - then English
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "Dialogs are used to make the value definition more");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "comfortable and to confirm/deny some actions.");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "Different sets of buttons are used depending");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "on the dialog type.");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "There are the following buttons we have:");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"0\"-\"9\" at the left");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"A\", \"B\", \"C\", \"D\" and \"E\" below the screen");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "\"<|>\" and \"ESC\" at the right");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "There is the following key-mapping at the moment:");
            y+=2*h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    SPECIFY VALUE:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"0\"-\"9\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    INCREASE VALUE ON X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"D\", \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    INCREASE VALUE ON 10*X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "long \"D\", \"|>\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    DECREASE VALUE ON X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"B\", \"<|\"");
            y+=h;
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    DECREASE VALUE ON 10*X:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "long \"B\", \"<|\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    RESET  VALUE:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"C\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    CONFIRM / SAVE AND EXIT:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"A\"");
            y+=h;              
            TextOutCenter(EINK, x, y, tw, th, 1, 0, "    DENY / CANCEL AND EXIT:");
            TextOutCenter(EINK, x+300, y, tw, th, 1, 0, "\"\", \"ESC\"");
            y+=h;              
        }
        break;
    }
}

int Help_Init(struct event *e) 
{
    return 0;
}

int Help_Exit(struct event *e) 
{
    return 0;
}

int Help_Show(struct event *e) 
{
    Help_Paint();
    return 0;
}

int Help_KeyPress(struct event *e) 
{
    int key = e->par1;
    switch (key) 
    {
    case KEY_PREV:
        help_page--;
        if (help_page<1) help_page=4;
        Help_Paint();        
        break;
    case KEY_NEXT:
        help_page++;
        if (help_page>4) help_page=1;
        Help_Paint();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_INFO:
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc help_evtproc[] = 
{
    { EVT_INIT, Help_Init },
    { EVT_SHOW, Help_Show },
    { EVT_KEYPRESS, Help_KeyPress },
    { EVT_EXIT, Help_Exit },
    { 0,    NULL },
};

void Help_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(help_evtproc, &evt);
    TranslateEvent(&evt);
}
