#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void cfgPg1_Paint() 
{                   
    ClearWindow(EINK);
    SetCurrFont(sysFont);

    DrawTop(opt_new.cfg_page);

    DrawCase(1, 1, 3, txt.cfg_page1_1_0);
    DrawCase(2, 1, 3, txt.cfg_page1_2_0);
    DrawCase(3, 1, 3, txt.cfg_page1_3_0);
    DrawCase(4, 1, 3, txt.cfg_page1_4_0);
    DrawCase(5, 1, 0, "");
    DrawCase(6, 1, 0, "");
    DrawCase(7, 1, 0, "");
    DrawCase(8, 1, 0, "");  
    DrawBot(txt.dialog_Ok, 0, 0, 0, txt.dialog_Cancel);
}

int cfgPg1_Init(struct event *e) 
{
    return 0;
}

int cfgPg1_Exit(struct event *e) 
{
    return 0;
}

int cfgPg1_Show(struct event *e) 
{
    cfgPg1_Paint();
    return 0;
}

int cfgPg1_KeyPress(struct event *e) 
{
    int key = e->par1;
    switch (key) 
    {
    case KEY_1: 
        help_page=1;
        ShowConfig(11);    
        break;
    case KEY_2: 
        help_page=2;
        ShowConfig(11);    
        break;
    case KEY_3:
        help_page=3;
        ShowConfig(11);    
        break;
    case KEY_4:
        help_page=4;
        ShowConfig(11);    
        break;
    case KEY_PREV:
        if (opt_new.cfg_page==1) opt_new.cfg_page = opt.cfg_page = 9;
        opt_new.cfg_page--;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_NEXT:
        if (opt_new.cfg_page==8) opt_new.cfg_page = opt.cfg_page = 0;
        opt_new.cfg_page++;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        exit_cfg_Cancel = 1;    
        config_changed = 0;
        CloseScreen();
        break;
    case KEY_INFO:
        config_changed = 1;
        exit_cfg_Ok = 1;
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc cfgPg1_evtproc[] = 
{
    { EVT_INIT, cfgPg1_Init },
    { EVT_SHOW, cfgPg1_Show },
    { EVT_KEYPRESS, cfgPg1_KeyPress },
    { EVT_EXIT, cfgPg1_Exit },
    { 0,    NULL },
};

void cfgPg1_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgPg1_evtproc, &evt);
    TranslateEvent(&evt);
}
