#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void cfgPg2_Paint() 
{
    char buf[256];
    ClearWindow(EINK);
    SetCurrFont(sysFont);

    DrawTop(opt_new.cfg_page);

    sprintf(buf, "%s%-1i", txt.cfg_page2_1_0, opt_new.profile_no+1);
    DrawCase(1, 1, 3, buf);

    sprintf(buf, "%s%i, %s", txt.cfg_page2_2_0, opt_new.style_no, txt.cfg_style[opt_new.style_no]);
    DrawCase(2, 1, 3, buf);

    int i;
    i = opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_r;
    if (i>=17)
    {
        SetCurrFont(1);
        memset(buf,0,256);
        sprintf(buf, "%s, PDB: %s", txt.cfg_page2_3_0, GetLongFontName(fonts[i]->PDB_file));
    }
    else
    {
        SetCurrFont(i);
        memset(buf,0,256);
        sprintf(buf, "%s", txt.cfg_page2_3_0);
    }
    DrawCase(3, 1, 3, buf);

    i = opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_b;
    if (i>=17)
    {
        SetCurrFont(2);
        memset(buf,0,256);
        sprintf(buf, "%s, PDB: %s", txt.cfg_page2_4_0, GetLongFontName(fonts[i]->PDB_file));
    }
    else
    {
        SetCurrFont(i);
        memset(buf,0,256);
        sprintf(buf, "%s", txt.cfg_page2_4_0);
    }
    DrawCase(4, 1, 3, buf);

    i = opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_i;
    if (i>=17)
    {
        SetCurrFont(3);
        memset(buf,0,256);
        sprintf(buf, "%s, PDB: %s", txt.cfg_page2_5_0, GetLongFontName(fonts[i]->PDB_file));
    }
    else
    {
        SetCurrFont(i);
        memset(buf,0,256);
        sprintf(buf, "%s", txt.cfg_page2_5_0);
    }
    DrawCase(5, 1, 3, buf);

    i = opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_bi;
    if (i>=17)
    {
        SetCurrFont(4);
        memset(buf,0,256);
        sprintf(buf, "%s, PDB: %s", txt.cfg_page2_6_0, GetLongFontName(fonts[i]->PDB_file));
    }
    else
    {
        SetCurrFont(i);
        memset(buf,0,256);
        sprintf(buf, "%s", txt.cfg_page2_6_0);
    }
    DrawCase(6, 1, 3, buf);

    SetCurrFont(sysFont);
    sprintf(buf, "Gamma: %i*0.25", opt_new.PDB_gamma);
    DrawCase(7, 1, 3, buf);

    DrawCase(8, 1, 0, "");  

    DrawBot(txt.dialog_Ok, 0, 0, 0, txt.dialog_Cancel);
}

int cfgPg2_Init(struct event *e) 
{
    return 0;
}

int cfgPg2_Exit(struct event *e) 
{
    return 0;
}

int cfgPg2_Show(struct event *e) 
{
    if (dialog.id == 2) 
    {
        opt_new.style_no = dialog.result;
        ResetDialog();
    }
    if (dialog.id == 7) 
    {
        opt_new.PDB_gamma = dialog.result;
        config_changed = 1;
        ResetDialog();
    }
    if (sel_font.id == 3) 
    {
        if (sel_font.result!=-1) 
        {
            opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_r = sel_font.result;
            config_resetStat = 1;
        }
        sel_font.id = 0;
        sel_font.result = -1;
    }
    if (sel_font.id == 4) 
    {
        if (sel_font.result!=-1) 
        {
            opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_b = sel_font.result;
            config_resetStat = 1;
        }
        sel_font.id = 0;
        sel_font.result = -1;
    }
    if (sel_font.id == 5) 
    {
        if (sel_font.result!=-1) 
        {
            opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_i = sel_font.result;
            config_resetStat = 1;
        }
        sel_font.id = 0;
        sel_font.result = -1;
    }
    if (sel_font.id == 6) 
    {
        if (sel_font.result!=-1) 
        {
            opt_new.profile[opt_new.profile_no].style[opt_new.style_no].font_bi = sel_font.result;
            config_resetStat = 1;
        }
        sel_font.id = 0;
        sel_font.result = -1;
    }
    cfgPg2_Paint();
    return 0;
}

int cfgPg2_KeyPress(struct event *e) 
{
    int key = e->par1;
    switch (key) 
    {
    case KEY_1: 
        opt_new.profile_no = 1 - opt_new.profile_no;
        config_resetStat = 1;
        config_changed = 1;
        cfgPg2_Paint();
        break;
    case KEY_2:
        opt_new.style_no = 1 - opt_new.style_no;
        cfgPg2_Paint();	  
        /*
    dialog.id = 2;
    dialog.case_no = 2;
    ShowDialog(opt_new.style_no, opt.style_no, 0, NUM_STYLES-1, 1, 4, txt.cfg_page2_2_0);
*/
        break;
    case KEY_3: 
        sel_font.id = 3;
        ShowConfig(9);    
        break;
    case KEY_4:
        sel_font.id = 4;
        ShowConfig(9);
        break;
    case KEY_5:
        sel_font.id = 5;
        ShowConfig(9);
        break;
    case KEY_6:
        sel_font.id = 6;
        ShowConfig(9);
        break;
    case KEY_7:
        dialog.id = 7;
        dialog.case_no = 7;
        ShowDialog(opt_new.PDB_gamma, opt_new.PDB_gamma, 1, 12, 1, 4, "Gamma");
        break;
    case KEY_8:
        break;
    case KEY_PREV:
        if (opt_new.cfg_page==1) opt_new.cfg_page = opt.cfg_page = 9;
        opt_new.cfg_page--;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_NEXT:
        if (opt_new.cfg_page==8) opt_new.cfg_page = opt.cfg_page = 0;
        opt_new.cfg_page++;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        exit_cfg_Cancel = 1;  
        config_changed = 0;
        CloseScreen();
        break;
    case KEY_INFO:
        config_changed = 1;
        exit_cfg_Ok = 1;
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc cfgPg2_evtproc[] = 
{
    { EVT_INIT, cfgPg2_Init },
    { EVT_SHOW, cfgPg2_Show },
    { EVT_KEYPRESS, cfgPg2_KeyPress },
    { EVT_EXIT, cfgPg2_Exit },
    { 0,    NULL },
};

void cfgPg2_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgPg2_evtproc, &evt);
    TranslateEvent(&evt);
}
