#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void cfgPg3_Paint() 
{
    char buf[256];
    ClearWindow(EINK);
    SetCurrFont(sysFont);

    DrawTop(opt_new.cfg_page);

    sprintf(buf, "%s%-1i", txt.cfg_page2_1_0, opt_new.profile_no+1);
    DrawCase(1, 1, 3, buf);

    sprintf(buf, "%s%i, %s", txt.cfg_page2_2_0, opt_new.style_no, txt.cfg_style[opt_new.style_no]);
    DrawCase(2, 1, 3, buf);

    sprintf(buf, "%s: %-2i", txt.cfg_page3_3_0, 
    opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.indent);
    if (opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.indent != 0) 
    {
        DrawCase(3, 1, 2, buf);
    } 
    else 
    {
        DrawCase(3, 1, 1, buf);
    }

    sprintf(buf, "%s: %-2i", txt.cfg_page3_4_0,
    opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.line_spacing);
    if (opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.line_spacing != 0) 
    {
        DrawCase(4, 1, 2, buf);
    } 
    else 
    {
        DrawCase(4, 1, 1, buf);
    }

    sprintf(buf, "%s: %-2i", txt.cfg_page3_5_0,
    opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.paragraph_spacing);
    if (opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.paragraph_spacing != 0) 
    {
        DrawCase(5, 1, 2, buf);
    } 
    else 
    {
        DrawCase(5, 1, 1, buf);
    }

    switch (opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.alignment) 
    {
    case 0:  
        sprintf(buf, "%s: %s", txt.cfg_page3_6, txt.cfg_page3_6_0); 
        break;
    case 1:  
        sprintf(buf, "%s: %s", txt.cfg_page3_6, txt.cfg_page3_6_1); 
        break;
    case 2:  
        sprintf(buf, "%s: %s", txt.cfg_page3_6, txt.cfg_page3_6_2); 
        break;
    case 3:  
        sprintf(buf, "%s: %s", txt.cfg_page3_6, txt.cfg_page3_6_3); 
        break;
    }
    DrawCase(6, 1, 3, buf);

    if (opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.hyphenation == 0) 
    {
        sprintf(buf, "%s: %s", txt.cfg_page3_7, txt.Off);
        DrawCase(7, 1, 1, buf);
    } 
    else 
    {
        sprintf(buf, "%s: %s", txt.cfg_page3_7, txt.On);
        DrawCase(7, 1, 2, buf);
    }

    sprintf(buf, "%s: %-2i", txt.cfg_page3_8, opt_new.hyph_before_after);
    DrawCase(8, 1, 2, buf);
    
    DrawBot(txt.dialog_Ok, 0, 0, 0, txt.dialog_Cancel);
}

int cfgPg3_Init(struct event *e) 
{
    return 0;
}

int cfgPg3_Exit(struct event *e) 
{
    return 0;
}

int cfgPg3_Show(struct event *e) 
{
    if (dialog.id == 2) 
    {
        opt_new.style_no = dialog.result;
        ResetDialog();
    }

    if (dialog.id == 3) 
    {
        opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.indent = dialog.result;
        ResetDialog();
    }

    if (dialog.id == 4) 
    {
        opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.line_spacing = dialog.result;
        ResetDialog();
    }

    if (dialog.id == 5) 
    {
        opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.paragraph_spacing = dialog.result;
        ResetDialog();
    }

    if (dialog.id == 8) 
    {
        opt_new.hyph_before_after = dialog.result;
        ResetDialog();
    }

    cfgPg3_Paint();
    return 0;
}

int cfgPg3_KeyPress(struct event *e) 
{
    int key = e->par1;
    switch (key) 
    {
    case KEY_1:
        opt_new.profile_no = 1 - opt_new.profile_no;
        config_resetStat = 1;	  
        config_changed = 1;
        cfgPg3_Paint();
        break;
    case KEY_2:
        opt_new.style_no = 1 - opt_new.style_no;
        cfgPg3_Paint();	  
        /*
    dialog.id = 2;
    dialog.case_no = 2;
    ShowDialog(opt_new.style_no, opt.style_no, 0, NUM_STYLES-1, 1, 4, txt.cfg_page2_2_0);
*/
        break;
    case KEY_3:
        dialog.id = 3;
        dialog.case_no = 3;
        ShowDialog(opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.indent, 
                   opt.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.indent, 
                   0, 30, 1, 3, txt.cfg_page3_3_0);
        break;
    case KEY_4:
        dialog.id = 4;
        dialog.case_no = 4;
        ShowDialog(opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.line_spacing, 
                   opt.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.line_spacing, 
                   -24, 48, 1, 3, txt.cfg_page3_4_0);
        break;
    case KEY_5:
        dialog.id = 5;
        dialog.case_no = 5;
        ShowDialog(opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.paragraph_spacing, 
                   opt.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.paragraph_spacing, 
                   0, 48, 1, 3, txt.cfg_page3_5_0);
        break;
    case KEY_6:
        opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.alignment++;
        if (opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.alignment == 4) 
            opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.alignment = 0;
        cfgPg3_Paint();
        break;
    case KEY_7:
        opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.hyphenation = 
            1 - opt_new.profile[opt_new.profile_no].style[opt_new.style_no].paragraph.hyphenation;
        cfgPg3_Paint();
        break;
    case KEY_8:
        dialog.id = 8;
        dialog.case_no = 8;
        ShowDialog(opt_new.hyph_before_after, opt.hyph_before_after, 1, 5, 1, 3, txt.cfg_page3_8);
        break;
    case KEY_PREV:
        if (opt_new.cfg_page==1) opt_new.cfg_page = opt.cfg_page = 9;
        opt_new.cfg_page--;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_NEXT:
        if (opt_new.cfg_page==8) opt_new.cfg_page = opt.cfg_page = 0;
        opt_new.cfg_page++;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        exit_cfg_Cancel = 1;    
        config_changed = 0;
        CloseScreen();
        break;
    case KEY_INFO:
        config_changed = 1;
        exit_cfg_Ok = 1;
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc cfgPg3_evtproc[] = 
{
    { EVT_INIT, cfgPg3_Init },
    { EVT_SHOW, cfgPg3_Show },
    { EVT_KEYPRESS, cfgPg3_KeyPress },
    { EVT_EXIT, cfgPg3_Exit },
    { 0,    NULL },
};

void cfgPg3_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgPg3_evtproc, &evt);
    TranslateEvent(&evt);
}
