#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void cfgPg4_Paint() 
{  
    char buf[256];

    ClearWindow(EINK);
    SetCurrFont(sysFont);

    DrawTop(opt_new.cfg_page);

    sprintf(buf, "%s: %-3i", txt.cfg_page4_1_0, opt_new.page.layout*90);
    DrawCase(1, 1, 3, buf); 

    sprintf(buf, "%s: %-3i", txt.cfg_page4_2_0, opt_new.page.margin_t);
    if (opt_new.page.margin_t != 0) 
    {
        DrawCase(2, 1, 2, buf);
    } 
    else 
    {
        DrawCase(2, 1, 1, buf);
    }

    sprintf(buf, "%s: %-3i", txt.cfg_page4_3_0, opt_new.page.margin_b);
    if (opt_new.page.margin_b != 0) 
    {
        DrawCase(3, 1, 2, buf);
    } 
    else 
    {
        DrawCase(3, 1, 1, buf);
    }

    sprintf(buf, "%s: %-3i", txt.cfg_page4_4_0, opt_new.page.margin_l);
    if (opt_new.page.margin_l != 0) 
    {
        DrawCase(4, 1, 2, buf);
    } 
    else 
    {
        DrawCase(4, 1, 1, buf);
    }

    sprintf(buf, "%s: %-3i", txt.cfg_page4_5_0, opt_new.page.margin_r);
    if (opt_new.page.margin_r != 0) 
    {
        DrawCase(5, 1, 2, buf);
    } 
    else 
    {
        DrawCase(5, 1, 1, buf);
    }

    switch (opt_new.page.alignment) 
    {
    case 0: 
        sprintf(buf, "%s: %s", txt.cfg_page4_6, txt.cfg_page4_6_0); 
        break;
    case 1: 
        sprintf(buf, "%s: %s", txt.cfg_page4_6, txt.cfg_page4_6_1); 
        break;
    case 2: 
        sprintf(buf, "%s: %s", txt.cfg_page4_6, txt.cfg_page4_6_2); 
        break;
    case 3: 
        sprintf(buf, "%s: %s", txt.cfg_page4_6, txt.cfg_page4_6_3); 
        break;
    }
    DrawCase(6, 1, 3, buf);

    DrawCase(7, 1, 0, "");
    DrawCase(8, 1, 0, "");  
    DrawBot(txt.dialog_Ok, 0, 0, 0, txt.dialog_Cancel);
}

int cfgPg4_Init(struct event *e) 
{
    return 0;
}

int cfgPg4_Exit(struct event *e) 
{
    return 0;
}

int cfgPg4_Show(struct event *e) 
{
    if (dialog.id == 2) 
    {
        opt_new.page.margin_t = dialog.result;
        ResetDialog();
    }

    if (dialog.id == 3) 
    {
        opt_new.page.margin_b = dialog.result;
        ResetDialog();
    }

    if (dialog.id == 4) 
    {
        opt_new.page.margin_l = dialog.result;
        ResetDialog();
    }

    if (dialog.id == 5) 
    {
        opt_new.page.margin_r = dialog.result;
        ResetDialog();
    }

    cfgPg4_Paint();
    return 0;
}

int cfgPg4_KeyPress(struct event *e) 
{
    int key = e->par1;
    switch (key) 
    {
    case KEY_1:
        opt_new.page.layout++;    
        if (opt_new.page.layout==4) opt_new.page.layout = 0;
        cfgPg4_Paint();
        break;
    case KEY_2:
        dialog.id = 2;
        dialog.case_no = 2;
        ShowDialog(opt_new.page.margin_t, opt.page.margin_t, 0, 255, 1, 3, txt.cfg_page4_2_0);
        break;
    case KEY_3:
        dialog.id = 3;
        dialog.case_no = 3;
        ShowDialog(opt_new.page.margin_b, opt.page.margin_b, 0, 255, 1, 3, txt.cfg_page4_3_0);
        break;
    case KEY_4:
        dialog.id = 4;
        dialog.case_no = 4;
        ShowDialog(opt_new.page.margin_l, opt.page.margin_l, 0, 255, 1, 3, txt.cfg_page4_4_0);
        break;
    case KEY_5:
        dialog.id = 5;
        dialog.case_no = 5;
        ShowDialog(opt_new.page.margin_r, opt.page.margin_r, 0, 255, 1, 3, txt.cfg_page4_5_0);
        break;
    case KEY_6:
        opt_new.page.alignment++;
        if (opt_new.page.alignment == 4) opt_new.page.alignment = 0;
        cfgPg4_Paint();
        break;
    case KEY_7:
        break;
    case KEY_8:
        break;
    case KEY_PREV:
        if (opt_new.cfg_page==1) opt_new.cfg_page = opt.cfg_page = 9;
        opt_new.cfg_page--;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_NEXT:
        if (opt_new.cfg_page==8) opt_new.cfg_page = opt.cfg_page = 0;
        opt_new.cfg_page++;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        exit_cfg_Cancel = 1;    
        config_changed = 0;
        CloseScreen();
        break;
    case KEY_INFO:
        config_changed = 1;
        exit_cfg_Ok = 1;
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc cfgPg4_evtproc[] = 
{
    { EVT_INIT, cfgPg4_Init },
    { EVT_SHOW, cfgPg4_Show },
    { EVT_KEYPRESS, cfgPg4_KeyPress },
    { EVT_EXIT, cfgPg4_Exit },
    { 0,    NULL },
};

void cfgPg4_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgPg4_evtproc, &evt);
    TranslateEvent(&evt);
}
