#include "er.h"
#include "cfg_common.h"
#include "messages.h"

void cfgPg7_Paint() 
{ 
    ClearWindow(EINK);
    SetCurrFont(sysFont);

    DrawTop(opt_new.cfg_page);

    DrawCase(1, 1, 3, txt.cfg_page7_1_0);

    char buf[256];                  
    if (opt_new.confirm_exit == 0) 
    {
        sprintf(buf, "%s: %s", txt.cfg_page7_2_0, txt.Off);
        DrawCase(2, 1, 1, buf);
    } 
    else 
    {
        sprintf(buf, "%s: %s", txt.cfg_page7_2_0, txt.On);
        DrawCase(2, 1, 2, buf);
    }

    sprintf(buf, "%s. N=%-2i", txt.cfg_page7_3_0, opt_new.save_every);
    DrawCase(3, 1, 2, buf);

    DrawCase(4, 1, 3, txt.cfg_page7_4_0);

    DrawCase(5, 1, 0, "");
    DrawCase(6, 1, 0, "");
    DrawCase(7, 1, 0, "");
    DrawCase(8, 1, 0, "");  
    DrawBot(txt.dialog_Ok, 0, 0, 0, txt.dialog_Cancel);
}

int cfgPg7_Init(struct event *e) 
{
    return 0;
}

int cfgPg7_Exit(struct event *e) 
{
    return 0;
}

int cfgPg7_Show(struct event *e) 
{
    if (dialog.id == 3) 
    {
        opt_new.save_every = dialog.result;
        ResetDialog();
    }

    cfgPg7_Paint();
    return 0;
}

int cfgPg7_KeyPress(struct event *e) 
{
    int key = e->par1;
    switch (key) 
    {
    case KEY_1: 
        opt_new.lang = 1 - opt_new.lang;
        SetLang(opt_new.lang);
        cfgPg7_Paint();
        break;
    case KEY_2: 
        opt_new.confirm_exit = 1 - opt_new.confirm_exit;
        cfgPg7_Paint();
        break; 
    case KEY_3:
        dialog.id = 3;
        dialog.case_no = 3;
        ShowDialog(opt_new.save_every, opt.save_every, 1, 200, 1, 3, txt.cfg_page7_3_0);
        break;
    case KEY_4:
        ShowConfig(12);
        break;
    case KEY_PREV:
        if (opt_new.cfg_page==1) opt_new.cfg_page = opt.cfg_page = 9;
        opt_new.cfg_page--;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_NEXT:
        if (opt_new.cfg_page==8) opt_new.cfg_page = opt.cfg_page = 0;
        opt_new.cfg_page++;
        opt.cfg_page = opt_new.cfg_page;
        CloseScreen();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        exit_cfg_Cancel = 1;    
        config_changed = 0;
        CloseScreen();
        break;
    case KEY_INFO:
        config_changed = 1;
        exit_cfg_Ok = 1;
        CloseScreen();
        break;
    }
    return 0;
}

static const struct evtproc cfgPg7_evtproc[] = 
{
    { EVT_INIT, cfgPg7_Init },
    { EVT_SHOW, cfgPg7_Show },
    { EVT_KEYPRESS, cfgPg7_KeyPress },
    { EVT_EXIT, cfgPg7_Exit },
    { 0,    NULL },
};

void cfgPg7_Handler() 
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(cfgPg7_evtproc, &evt);
    TranslateEvent(&evt);
}
