#include "er.h"
#include "cfg_common.h"
#include "messages.h"

unsigned char sf_long_press;
int fnt_offset, fnt_page;
unsigned char font_pdb_no, *font_pdb_file;

void SelFont_DrawTop(int p)
{
    char buf[256];
    SetCurrFont(sysFont);

    DrawImageResource(EINK, 0, 0, "CONF_TOP");
    if (opt_new.lang == 0) DrawImageResource(EINK, 8, 8, "CONF_BAN_FONT_EN");
    if (opt_new.lang == 1) DrawImageResource(EINK, 8, 8, "CONF_BAN_FONT_RU");

    int x = 12;
    int y = 36;
    int tw0 = 56;
    int tw1 = 184;
    int th0 = 40;
    int th1 = 44;

    if (p == 1)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "1");
        x += tw0;
    }

    if (p == 2)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "2");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "2");
        x += tw0;
    }

    if (p == 3)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "3");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "3");
        x += tw0;
    }

    if (p == 4)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "4");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "4");
        x += tw0;
    }
}

void SelFont_Paint()
{
    int i;
    char buf[256];
    
    ClearWindow(EINK);

    SelFont_DrawTop(fnt_page);

    for (i=fnt_offset; i<(fnt_offset+8); i++)
    {
        if (i < MAX_FONTS)
        {
            if (fonts[i]->no!=0x333)
            {
                SetCurrFont(i);
                DrawCase(i-fnt_offset+1, 1, 3, txt.cfg_font);
            }
            else
            {
                if (fonts[i]->PDB_file[0]==0)
                {
                    SetCurrFont(sysFont);
                    DrawCase(i-fnt_offset+1, 1, 3, "<Empty slot>");
                }
                else
                {
                    //if (fonts[i]->pointer==NULL)
                    //{
                        SetCurrFont(sysFont);
                    //}
                    //else
                    //{
                    //    SetCurrFont(i);
                    //}
                    sprintf(buf, "PDB: %s", GetLongFontName(fonts[i]->PDB_file));
                    DrawCase(i-fnt_offset+1, 1, 3, buf);
                }
            }
        }
        else
        {
            DrawCase(i-fnt_offset+1, 1, 0, "");
        }
    }

    DrawBot(0, 0, 0, 0, txt.dialog_Cancel);
}

int SelFont_Init(struct event *e)
{

    sf_long_press=0;
    fnt_page = 1;
    fnt_offset = (fnt_page-1)*8;
    sel_font.result = -1;
    
    font_pdb_file = NULL;
    font_pdb_no = 0;
    
    return 0;
}

int SelFont_Exit(struct event *e)
{
    return 0;
}

int SelFont_Show(struct event *e)
{
    if (LOG) log("<SelFont_Show>\0");

    if (font_pdb_no>=17)
    {
        if (font_pdb_file!=NULL)
        {
            memcpy(fonts[font_pdb_no]->PDB_file, font_pdb_file, 12);
            fonts[font_pdb_no]->no = 0x333;
        
            free(font_pdb_file);
            font_pdb_file = NULL;
        }
        font_pdb_no = 0;
    }
    SelFont_Paint();

    if (LOG) log("</SelFont_Show>\0");
    return 0;
}

int SelFont_KeyPress(struct event *e)
{
    sf_long_press=0;
    int key = e->par1;

    switch (key)
    {
    case KEY_PREV:
        if (fnt_page != 1)
        {
            fnt_page--;
        }
        else
        {
            fnt_page = (MAX_FONTS-1)/8+1;
        }
        fnt_offset = (fnt_page-1)*8;
        SelFont_Paint();
        break;
    case KEY_NEXT:
        if (fnt_page < (MAX_FONTS-1)/8+1)
        {
            fnt_page++;
        }
        else
        {
            fnt_page = 1;
        }
        fnt_offset = (fnt_page-1)*8;
        SelFont_Paint();
        break;
    case KEY_SHELF:  e->type = 0;
    case KEY_ROTATE:
        CloseScreen();
        break;
    }
    return 0;
}

int SelFont_KeyRepeat(struct event *e)
{
    int key = e->par1;
    if (sf_long_press)
    {
        switch (key)
        {
        case KEY_0:
        case KEY_1:
        case KEY_2:
        case KEY_3:
        case KEY_4:
        case KEY_5:
        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            if ((key-0x31+fnt_offset)<MAX_FONTS)
            {
                int i=key-0x31+fnt_offset;
                if ((fonts[i]->no==0x333)&&(fonts[i]->PDB_file[0]!=0))
                {
                    if (fonts[i]->pointer!=NULL) 
                    {
                        ClosePDBfont(fonts[i]->pointer);
                        fonts[i]->pointer=NULL;
                        fonts[i]->height = 0;
                        fonts[i]->ascent = 0;
                    }
                    memset(fonts[i]->PDB_file,0,12);
                    SelFont_Paint();
                } 
            }
            break;
        }
    }
    sf_long_press=1;
    return 0;
}

int SelFont_KeyRelease(struct event *e)
{
    int key = e->par1;
    if (!sf_long_press)
    {
        switch (key)
        {
        case KEY_0:
        case KEY_1:
        case KEY_2:
        case KEY_3:
        case KEY_4:
        case KEY_5:
        case KEY_6:
        case KEY_7:
        case KEY_8:
        case KEY_9:
            if ((key-0x31+fnt_offset)<MAX_FONTS)
            {
                int i=key-0x31+fnt_offset;
                if ((i<17)||((i>=17)&&(fonts[i]->PDB_file[0]!=0)))
                {
                    sel_font.result = i;
                    config_changed = 1;
                    CloseScreen();
                } 
                else
                {
                    font_pdb_no = i;
                    ShowConfig(10);
                }
            }
            break;
        }
    }
    return 0;
}

static const struct evtproc selfont_evtproc[] =
{
    { EVT_INIT, SelFont_Init },
    { EVT_SHOW, SelFont_Show },
    { EVT_KEYPRESS, SelFont_KeyPress },
    { EVT_KEYRELEASE, SelFont_KeyRelease },
    { EVT_KEYREPEAT, SelFont_KeyRepeat },
    { EVT_EXIT, SelFont_Exit },
    { 0,    NULL },
};

void SelFont_Handler()
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(selfont_evtproc, &evt);
    TranslateEvent(&evt);
}
