#include "er.h"
#include "cfg_common.h"
#include "messages.h"

int filecount, filepage, top, fpage;
const unsigned char path[17] = "B:\\System\\Fonts\\";
extern unsigned char *font_pdb_file;

struct fileitem
{
    unsigned char name[12];
} *files;

int BuildFilesList()
{
    char buf[256];
    int ftype;
    char *p;

    filecount = 0;
    strcpy(buf, path);
    strcat(buf, "*.pdb");

    p = FindFirstFile(buf, &ftype, 0);
    while ((p != NULL)&&(filecount<64))
    {
        if (ftype == 0)
        {
            strcpy(files[filecount].name, p);
            filecount++;
        }
        p = FindNextFile(&ftype, 0);
    }
    return filecount;
}

char *GetLongFontName(char *file)
{
    static char out[64];
    char buf1[256];

    strcpy(buf1, path);
    strcat(buf1, file);
    GetLongName(buf1, out);
    return out;
}

void SelPDB_DrawTop(int p)
{
    char buf[256];

    SetCurrFont(sysFont);

    DrawImageResource(EINK, 0, 0, "CONF_TOP");
    if (opt_new.lang == 0) DrawImageResource(EINK, 8, 8, "CONF_BAN_FONT_EN");
    if (opt_new.lang == 1) DrawImageResource(EINK, 8, 8, "CONF_BAN_FONT_RU");

    int x = 12;
    int y = 36;
    int tw0 = 56;
    int tw1 = 184;
    int th0 = 40;
    int th1 = 44;

    if (p == 1)
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_1");
        sprintf(buf, "%s %s", txt.cfg_page4_title, "1");
        TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
        x += tw1;
    }
    else
    {
        DrawImageResource(EINK, x, y, "CONF_TAB_0");
        TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "1");
        x += tw0;
    }

    if (filepage>=2)
    {
        if (p == 2)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "2");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "2");
            x += tw0;
        }
    }

    if (filepage>=3)
    {
        if (p == 3)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "3");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "3");
            x += tw0;
        }
    }

    if (filepage>=4)
    {
        if (p == 4)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "4");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "4");
            x += tw0;
        }
    }

    if (filepage>=5)
    {
        if (p == 5)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "5");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "5");
            x += tw0;
        }
    }

    if (filepage>=6)
    {
        if (p == 6)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "6");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "6");
            x += tw0;
        }
    }

    if (filepage>=7)
    {
        if (p == 7)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "7");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "7");
            x += tw0;
        }
    }

    if (filepage>=8)
    {
        if (p == 8)
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_1");
            sprintf(buf, "%s %s", txt.cfg_page4_title, "8");
            TextOutCenter(EINK, x, y+4, tw1, th1, 0, 0, buf);
            x += tw1;
        }
        else
        {
            DrawImageResource(EINK, x, y, "CONF_TAB_0");
            TextOutCenter(EINK, x, y+4, tw0, th0, 0, 0, "8");
            x += tw0;
        }
    }
}

void SelPDB_Paint()
{
    int i;

    ClearWindow(EINK);
    SelPDB_DrawTop(fpage);

    for (i=top; i<(top+8); i++)
    {
        if (i < filecount)
        {
            DrawCase(i-top+1, 1, 3, GetLongFontName(files[i].name));
        }
        else
        {
            DrawCase(i-top+1, 1, 0, "");
        }
    }
    DrawBot(0, 0, 0, 0, txt.dialog_Cancel);
}

int SelPDB_Init(struct event *e)
{
    files = (struct fileitem *)calloc(64 * sizeof(struct fileitem));
    
    filecount = BuildFilesList();
    filepage = filecount/8+1;
    if (filepage>8) filepage=8;
    
    top = 0;
    fpage = 1;

    if (font_pdb_file!=NULL) free(font_pdb_file);
    font_pdb_file = NULL;
    
    return 0;
}

int SelPDB_Exit(struct event *e)
{
    free(files);
    files=NULL;
    return 0;
}

int SelPDB_Show(struct event *e)
{
    SelPDB_Paint();
    return 0;
}

int SelPDB_KeyPress(struct event *e)
{
    int key = e->par1;

    if ((key>0x30)&&(key<0x39)&&((key-0x31+top)<filecount))
    {
        font_pdb_file = calloc(12);
        strcpy(font_pdb_file, files[(key-0x31)+top].name);
        CloseScreen();
    }
    else
    {
        switch (key)
        {
        case KEY_PREV:
            fpage--;
            if (fpage==0) fpage = filepage;
            top = (fpage-1)*8;
            SelPDB_Paint();
            break;
        case KEY_NEXT:
            fpage++;
            if (fpage>filepage) fpage = 1;
            top = (fpage-1)*8;
            SelPDB_Paint();
            break;
        case KEY_SHELF:  e->type = 0;
        case KEY_ROTATE:
            CloseScreen();
            break;
        }
    }
    return 0;
}

static const struct evtproc selPDB_evtproc[] =
{
    { EVT_INIT, SelPDB_Init },
    { EVT_SHOW, SelPDB_Show },
    { EVT_KEYPRESS, SelPDB_KeyPress },
    { EVT_EXIT, SelPDB_Exit },
    { 0,    NULL },
};

void SelPDB_Handler()
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(selPDB_evtproc, &evt);
    TranslateEvent(&evt);
}
