#include "er.h"
#include "cfg_common.h"
#include "actions.h"

void SetDefOptions(struct options_struct *opt_def)
{
    memset(opt_def, 0, sizeof(struct options_struct));

    opt_def->version = version;
    opt_def->cfg_page = 1;
    opt_def->profile_no = 0;
    opt_def->style_no = 0;
    opt_def->lang = GetSysLanguage();
    if (opt_def->lang>1) opt_def->lang = 0;
    opt_def->confirm_exit = 0;
    opt_def->hyph_before_after = 2;
    opt_def->save_every = 10;
    opt_def->PDB_gamma = 8;

    opt_def->key_mapping[sKEY_1] = aBKMARK_SET;
    opt_def->key_mapping[sKEY_2] = aBKMARK_PREV;
    opt_def->key_mapping[sKEY_3] = aBKMARK_NEXT;
    opt_def->key_mapping[sKEY_4] = aRETURN;
    opt_def->key_mapping[sKEY_5] = aGOTO_FIRST;
    opt_def->key_mapping[sKEY_6] = aGOTO_LAST;
    opt_def->key_mapping[sKEY_7] = aPREV_PAGE;
    opt_def->key_mapping[sKEY_8] = aNEXT_PAGE;
    opt_def->key_mapping[sKEY_9] = aLOCK;
    opt_def->key_mapping[sKEY_A] = aNEXT_PAGE;
    opt_def->key_mapping[sKEY_B] = aFULL_SCR;
    opt_def->key_mapping[sKEY_C] = aPROFILE;
    opt_def->key_mapping[sKEY_D] = aGOTO_PROC;
    opt_def->key_mapping[sKEY_E] = aROTATE;
    opt_def->key_mapping[sKEY_LEFT] = aPREV_PAGE;
    opt_def->key_mapping[sKEY_RIGHT] = aNEXT_PAGE;

    opt_def->key_mapping[lKEY_1] = aBKMARK_SHOW;
    opt_def->key_mapping[lKEY_2] = aFREE;
    opt_def->key_mapping[lKEY_3] = aFREE;
    opt_def->key_mapping[lKEY_4] = aFREE;
    opt_def->key_mapping[lKEY_5] = aFREE;
    opt_def->key_mapping[lKEY_6] = aFREE;
    opt_def->key_mapping[lKEY_7] = aFREE;
    opt_def->key_mapping[lKEY_8] = aFREE;
    opt_def->key_mapping[lKEY_9] = aFREE;
    opt_def->key_mapping[lKEY_A] = aFREE;
    opt_def->key_mapping[lKEY_B] = aFREE;
    opt_def->key_mapping[lKEY_C] = aFREE;
    opt_def->key_mapping[lKEY_D] = aGOTO_PAGE;
    opt_def->key_mapping[lKEY_E] = aFREE;
    opt_def->key_mapping[lKEY_LEFT] = aPREV_10PAGES;
    opt_def->key_mapping[lKEY_RIGHT] = aNEXT_10PAGES;

    opt_def->statusbar_t.font = 3;
    opt_def->statusbar_t.visible = 1;
    opt_def->statusbar_t.progress = 1;
    opt_def->statusbar_t.battery = 2;
    opt_def->statusbar_t.info = 6;
    opt_def->statusbar_t.style = 3;
    opt_def->statusbar_t.color = 7;
    opt_def->statusbar_t.height = 32;
    opt_def->statusbar_t.time = 5;

    opt_def->statusbar_b.font = 3;
    opt_def->statusbar_b.visible = 0;
    opt_def->statusbar_b.progress = 1;
    opt_def->statusbar_b.battery = 5;
    opt_def->statusbar_b.info = 6;
    opt_def->statusbar_b.style = 3;
    opt_def->statusbar_b.color = 7;
    opt_def->statusbar_b.height = 0;
    opt_def->statusbar_b.time = 4;

    opt_def->page.margin_r = 10;
    opt_def->page.margin_l = 10;
    opt_def->page.margin_t = 10;
    opt_def->page.margin_b = 10;
    opt_def->page.alignment = 0;
    opt_def->page.layout = 0;
    opt_def->page.fullscr = 0;

    opt_def->profile[0].style[0].font_r = 5;
    opt_def->profile[0].style[0].font_b = 6;
    opt_def->profile[0].style[0].font_i = 7;
    opt_def->profile[0].style[0].font_bi= 8;
    opt_def->profile[0].style[0].paragraph.indent = 4;
    opt_def->profile[0].style[0].paragraph.line_spacing = -6;
    opt_def->profile[0].style[0].paragraph.paragraph_spacing = 10;
    opt_def->profile[0].style[0].paragraph.alignment = 3;
    opt_def->profile[0].style[0].paragraph.hyphenation = 1;

    opt_def->profile[0].style[1].font_r = 9;
    opt_def->profile[0].style[1].font_b = 10;
    opt_def->profile[0].style[1].font_i = 11;
    opt_def->profile[0].style[1].font_bi= 12;
    opt_def->profile[0].style[1].paragraph.indent = 0;
    opt_def->profile[0].style[1].paragraph.line_spacing = 0;
    opt_def->profile[0].style[1].paragraph.paragraph_spacing = 10;
    opt_def->profile[0].style[1].paragraph.alignment = 2;
    opt_def->profile[0].style[1].paragraph.hyphenation = 0;

    opt_def->profile[1].style[0].font_r = 1;
    opt_def->profile[1].style[0].font_b = 2;
    opt_def->profile[1].style[0].font_i = 3;
    opt_def->profile[1].style[0].font_bi= 4;
    opt_def->profile[1].style[0].paragraph.indent = 4;
    opt_def->profile[1].style[0].paragraph.line_spacing = -4;
    opt_def->profile[1].style[0].paragraph.paragraph_spacing = 10;
    opt_def->profile[1].style[0].paragraph.alignment = 3;
    opt_def->profile[1].style[0].paragraph.hyphenation = 1;

    opt_def->profile[1].style[1].font_r = 5;
    opt_def->profile[1].style[1].font_b = 6;
    opt_def->profile[1].style[1].font_i = 7;
    opt_def->profile[1].style[1].font_bi= 8;
    opt_def->profile[1].style[1].paragraph.indent = 0;
    opt_def->profile[1].style[1].paragraph.line_spacing = 0;
    opt_def->profile[1].style[1].paragraph.paragraph_spacing = 10;
    opt_def->profile[1].style[1].paragraph.alignment = 2;
    opt_def->profile[1].style[1].paragraph.hyphenation = 0;

    // this block is needed for a future, when NUM_STYLES>2
    int i;
    for (i=2;i<NUM_STYLES;i++)
    {
        opt_def->profile[0].style[i].font_r = 5;
        opt_def->profile[0].style[i].font_b = 6;
        opt_def->profile[0].style[i].font_i = 7;
        opt_def->profile[0].style[i].font_bi= 8;
        opt_def->profile[0].style[i].paragraph.indent = 4;
        opt_def->profile[0].style[i].paragraph.line_spacing = 0;
        opt_def->profile[0].style[i].paragraph.paragraph_spacing = 8;
        opt_def->profile[0].style[i].paragraph.alignment = 3;
        opt_def->profile[0].style[i].paragraph.hyphenation = 1;

        opt_def->profile[1].style[i].font_r = 5;
        opt_def->profile[1].style[i].font_b = 6;
        opt_def->profile[1].style[i].font_i = 7;
        opt_def->profile[1].style[i].font_bi= 8;
        opt_def->profile[1].style[i].paragraph.indent = 4;
        opt_def->profile[1].style[i].paragraph.line_spacing = 0;
        opt_def->profile[1].style[i].paragraph.paragraph_spacing = 8;
        opt_def->profile[1].style[i].paragraph.alignment = 3;
        opt_def->profile[1].style[i].paragraph.hyphenation = 1;
    }
}
