#include "er.h"
#include "cfg_common.h"
#include "messages.h"

unsigned char d_long_press;
unsigned char d_first;

void Dialog_Handler();

void ShowDialog(int val, int def, int min, int max, int step, unsigned char type, char *text)
{
    dialog.val = val;
    dialog.result = val;
    dialog.min = min;
    dialog.max = max;
    dialog.def = def;
    dialog.step = step;
    dialog.text = text;
    dialog.type = type;
    OpenScreen(0, Dialog_Handler, "Dialog", 7010);
}

void ResetDialog()
{
    dialog.val = 0;
    dialog.result = 0;
    dialog.min = 0;
    dialog.max = 0;
    dialog.def = 0;
    dialog.step = 0;
    dialog.text = 0;
    dialog.id = 0;
    dialog.type = 0;
    dialog.case_no = 8;
}

void Dialog_Paint()
{
    char buf[256];

    if (dialog.type == 2)
    {
        SetCurrFont(sysFont);
        FillArea(1902, 0, 10, 500, 60, 3, AND);

        sprintf(buf, "%s: %-4i", dialog.text, dialog.result);
        TextOutCenter(1902, 0, 0, 540, 80, 1, 0, buf);
        WindowFunction(1902, OUT_TO_LCD);
    }
}

int Dialog_Init(struct event *e)
{
    char buf[256], buf1[10], buf2[10];
    d_long_press=0;
    d_first = 1;
    
    int type;
    type = dialog.type-1;
    if (dialog.type == 2) type = 0;
    if (dialog.type > 2) dialog.type = 2;

    if ((opt.page.layout==1)||(opt.page.layout==3)) SetLayout(EINK, 0);

    SetCurrFont(sysFont);
    FillArea(EINK, 0, 0, 600, 800, 2, SET);

    FillArea(EINK, 0, dialog.case_no*80-12, 600, 80+12+12, 3, AND);
    FillArea(EINK, 0, 720, 600, 80, 3, AND);

    DrawImageResource(EINK, 0, dialog.case_no*80-8, "DIALOG_TOP");
    DrawImageResource(EINK, 0, (dialog.case_no+1)*80, "CONF_BOT");

    if (dialog.type == 1)
    {
        sprintf(buf, "%s", dialog.text);
        DrawCase(8, 1, 0, buf);
        DrawBot(txt.yes, 0, 0, 0, txt.no);
    }
    if (dialog.type == 2)
    {
        sprintf(buf, "%s: %-4i", dialog.text, dialog.result);
        sprintf(buf1, "-%-4i", dialog.step);
        sprintf(buf2, "+%-4i", dialog.step);
        DrawCase(dialog.case_no, 1, type, buf);
        DrawBot(txt.dialog_Ok, buf1, txt.dialog_Reset, buf2, txt.dialog_Cancel);
    }

    CreateWindow(1902, 60, 80*dialog.case_no, 540, 80, EINK, 0);
    
    WindowFunction(1902, COPY_FROM_PARENT);
    return 0;
}

int Dialog_Exit(struct event *e)
{
    DeleteWindow(1902);
    return 0;
}

int Dialog_Show(struct event *e)
{
    Dialog_Paint();
    return 0;
}

int Dialog_KeyPress(struct event *e)
{
    d_long_press=0;

    int key = e->par1;
    switch (key)
    {
    case KEY_SHELF: e->type = 0;
    case KEY_ROTATE:
        if (dialog.type == 1) dialog.result = 0;
        if (dialog.type == 2) dialog.result = dialog.val;
        CloseScreen();
        break;
    case KEY_INFO:
        if ((dialog.type == 2)&&((dialog.result<dialog.min)||(dialog.result>dialog.max)))
        {
            char buf[256];
            sprintf(buf, "%s. Min=%i, Max=%i.", txt.dialog_Wrong, dialog.min, dialog.max);
            Alert(buf, 1, 1);
            Dialog_Paint();
            break;
        }
        if (dialog.type == 1) dialog.result = 1;
        CloseScreen();
        break;
    }
    e->type=0;
    return 0;
}

int Dialog_KeyRepeat(struct event *e)
{
    d_long_press=1;

    int key = e->par1;
    switch (key)
    {
    case KEY_PREV:
    case KEY_CONTENTS:
        if (dialog.type == 2)
        {
            if ((dialog.result-10*dialog.step) < dialog.min)
            {
                dialog.result = dialog.min;
            }
            else
            {
                dialog.result -= 10*dialog.step;
            }
            Dialog_Paint();
        }
        break;
    case KEY_NEXT:
    case KEY_PAGE:
        if (dialog.type == 2)
        {
            if ((dialog.result+10*dialog.step) > dialog.max)
            {
                dialog.result = dialog.max;
            }
            else
            {
                dialog.result += 10*dialog.step;
            }
            Dialog_Paint();
        }
        break;
    }
    e->type=0;    
    return 0;
}

int Dialog_KeyRelease(struct event *e)
{
    if (d_long_press) return 0;

    int key = e->par1;
    switch (key)
    {
    case KEY_0:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 0;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10;
            }
            Dialog_Paint();
        }
        break;
    case KEY_1:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 1;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+1;
            }
            Dialog_Paint();
        }
        break;
    case KEY_2:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 2;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+2;
            }
            Dialog_Paint();
        }
        break;
    case KEY_3:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 3;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+3;
            }
            Dialog_Paint();
        }
        break;
    case KEY_4:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 4;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+4;
            }
            Dialog_Paint();
        }
        break;
    case KEY_5:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 5;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+5;
            }
            Dialog_Paint();
        }
        break;
    case KEY_6:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 6;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+6;
            }
            Dialog_Paint();
        }
        break;
    case KEY_7:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 7;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+7;
            }
            Dialog_Paint();
        }
        break;
    case KEY_8:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 8;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+8;
            }
            Dialog_Paint();
        }
        break;
    case KEY_9:
        if (dialog.type == 2)
        {
            if (d_first)
            {
                dialog.result = 9;
                d_first = 0;
            }
            else
            {
                dialog.result = (dialog.result-((dialog.result/100)*100))*10+9;
            }
            Dialog_Paint();
        }
        break;
    case KEY_PREV:
    case KEY_CONTENTS:
        if ((dialog.type == 2)&&(dialog.result > dialog.min))
        {
            dialog.result -= dialog.step;
            Dialog_Paint();
        }
        break;
    case KEY_ZOOM:
        if (dialog.type == 2)
        {
            dialog.result = dialog.def;
            Dialog_Paint();
        }
        break;
    case KEY_NEXT:
    case KEY_PAGE:
        if ((dialog.type == 2)&&(dialog.result < dialog.max))
        {
            dialog.result += dialog.step;
            Dialog_Paint();
        }
        break;
    }
    e->type = 0;
    return 0;
}


static const struct evtproc Dialog_evtproc[] =
{
    { EVT_INIT, Dialog_Init },
    { EVT_SHOW, Dialog_Show },
    { EVT_KEYPRESS, Dialog_KeyPress },
    { EVT_KEYRELEASE, Dialog_KeyRelease },
    { EVT_KEYREPEAT, Dialog_KeyRepeat },
    { EVT_EXIT, Dialog_Exit },
    { 0,    NULL },
};

void Dialog_Handler()
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(Dialog_evtproc, &evt);
    TranslateEvent(&evt);
}
