#include "er.h"
#include "all_extern.h"
#include "utf8.h"

void FindCrap()
{
    if (LOG) log("<FindCrap>\0");

    char *cc, *tag;
    int size, i, temp;
    long int offset=0;

    tag = calloc(16*sizeof(unsigned char));
    
    SeekFile(fd, 100, SEEK_END);
    if (ReadFile(fd, pagebuffer, 100, &size) != 0) goto end;

    offset = 100;
    cc = pagebuffer;
    for (i=0;i<size;i++)
    {
        if (*cc=='<')
        {
            memset(tag, 0, 16);
            temp = DefineTag(cc, tag);
            if (WordsComp(tag, "/body")) goto end;
            cc += temp;
            i += temp;
            offset -= temp;
        }
        cc++;
        offset--;
    }

    // if there are some images, we need to cut them from statistics
    SeekFile(fd, -2*BUFF_SIZE, SEEK_CUR);
    if (ReadFile(fd, pagebuffer, 2*BUFF_SIZE, &size) != 0) goto end;
    offset = 2*BUFF_SIZE;
    while(1)
    {
        if (offset>fd_size) break;
        cc = pagebuffer;
        for (i=0;i<size;i++)
        {
            if (*cc=='<')
            {
                memset(tag, 0, 16);
                temp = DefineTag(cc, tag);
                if (WordsComp(tag, "/body"))
                {
                    fd_size-=offset;
                    goto end;
                }
                cc+=temp;
                i+=temp;
                offset-=temp;
            }
            cc++;
            offset--;
        }
        SeekFile(fd, -(4*BUFF_SIZE-32), SEEK_CUR);
        if (ReadFile(fd, pagebuffer, 2*BUFF_SIZE, &size) != 0) goto end;
        offset += 4*BUFF_SIZE-32;
    }

end:
    free(tag);
    tag=NULL;

    return;
}

void FileTypeDef ()
{
    if (LOG) log("<FileTypeDef>\0");

    char *cc, *tag, *authors, *title;
    int size, i, temp;

    int countt, counta;
    int a=0, b=0;
    unsigned char t_descr=0, t_title=0, t_auth=0, auth_no=0;

    SeekFile(fd, 0, SEEK_SET);
    if (ReadFile(fd, pagebuffer, BUFF_SIZE, &size) != 0) return;

    tag = calloc(16*sizeof(unsigned char));
    
    cc = pagebuffer;
    file_type = 0;
    for (i=0;i<size;i++)
    {
        if (*cc=='<')
        {
            memset(tag, 0, 16);
            temp = DefineTag(cc, tag);
            if (WordsComp(tag, "?xml"))
            {
                file_type = 1;
                while (!((*cc=='e')&&(*(cc+1)=='n')&&(*(cc+2)=='c')))
                {
                    cc++;
                    i++;
                    if (i>(size-16)) break;
                }
                cc+=10;
                i+=10;
                if ((WordsComp(cc, "UTF"))||(WordsComp(cc, "utf")))
                {
                    codepage = 1;
                    break;
                }
                else
                {
                    break;
                }
            }
            cc += temp;
            i += temp;
        }
        cc++;
    }

    if (file_type==1)
    {
        if (codepage==1) DecodeUTF8(pagebuffer, size-16, &a, &b);
        cc = pagebuffer;
        authors = fb2_authors;
        title = fb2_title;
        countt = 0;
        counta = 0;
        for (i=0;i<size;i++)
        {
            if (*cc=='<')
            {
                memset(tag, 0, 16);
                temp = DefineTag(cc, tag);

                if (WordsComp(tag, "description")) t_descr = 1;
                if (WordsComp(tag, "/description"))
                {
                    t_descr = 0;
                    break;
                }

                if ((WordsComp(tag, "title-info"))&&(t_descr == 1))  t_title = 1;
                if ((WordsComp(tag, "/title-info"))&&(t_descr == 1))
                {
                    t_title = 0;
                    break;
                }

                if ((WordsComp(tag, "book-title"))&&(t_descr == 1)&&(t_title == 1))
                {
                    cc+=temp;
                    i+=temp;
                    cc++;
                    while ((*cc!='<')&&(countt<256))
                    {
                        *title = *cc;
                        title++;
                        cc++;
                        countt++;
                    }
                }

                if ((WordsComp(tag, "author"))&&(t_descr == 1)&&(t_title == 1))
                t_auth = 1;
                if ((WordsComp(tag, "/author"))&&(t_descr == 1)&&(t_title == 1))
                t_auth = 0;

                if ((WordsComp(tag, "first-name"))
                        &&(t_descr == 1)&&(t_title == 1)&&(t_auth == 1)
                        &&(counta<252)) {
                    auth_no++;
                    if (auth_no>1)
                    {
                        *authors = ',';
                        authors++;
                        counta++;
                        *authors = ' ';
                        authors++;
                        counta++;
                    }
                    cc+=temp;
                    i+=temp;
                    cc++;
                    *authors = *cc;
                    authors++;
                    counta++;
                    *authors = '.';
                    authors++;
                    counta++;
                }
                if ((WordsComp(tag, "last-name"))
                        &&(t_descr == 1)&&(t_title == 1)&&(t_auth == 1)
                        &&(counta<256))
                {
                    cc+=temp;
                    i+=temp;
                    cc++;
                    while ((*cc!=' ')&&(*cc!='<')&&(counta<256))
                    {
                        *authors = *cc;
                        authors++;
                        cc++;
                        counta++;
                    }
                }
            }
            cc++;
        }
        FindCrap();
    }
    free(tag);
    tag=NULL;

    if (LOG) log("</FileTypeDef>\0");
}

void FreeStyleTree()
{
    struct styles_tree *tmp;
    while (curr_style->prev!=0)
    {
        tmp = curr_style->prev;
        free(curr_style);
        
        curr_style = tmp;
    }
}

void Start(int p)
{
    page[p].start = 0;
    page[p].line[0].flags = 2;
    FreeStyleTree();
    FileTypeDef();
}

void SavePosition()
{
    if (LOG) log("<SavePosition>\0");

    int cf, size, fb2a_tmp, fb2t_tmp;
    DeleteFile(pos_filename);
    cf = CreateFile(pos_filename);
    WriteFile(cf, &version, sizeof(int), &size);
    WriteFile(cf, &page[curr_page].start, sizeof(long int), &size);
    WriteFile(cf, &page[curr_page].line[0].flags, sizeof(unsigned char), &size);
    WriteFile(cf, &file_type, sizeof(unsigned char), &size);
    WriteFile(cf, &codepage, sizeof(unsigned char), &size);
    WriteFile(cf, &fd_size, sizeof(long int), &size);
    fb2a_tmp = strlen(fb2_authors);
    WriteFile(cf, &fb2a_tmp, sizeof(int), &size);
    WriteFile(cf, fb2_authors, fb2a_tmp, &size);
    fb2t_tmp = strlen(fb2_title);
    WriteFile(cf, &fb2t_tmp, sizeof(int), &size);
    WriteFile(cf, fb2_title, fb2t_tmp, &size);
    WriteFile(cf, stat, sizeof(struct statistics), &size);

    struct styles_tree *tmp;
    tmp = curr_style;
    while (tmp->prev!=0) tmp = tmp->prev;
    while (tmp->next!=0)
    {
        WriteFile(cf, &tmp->no, sizeof(unsigned char), &size);
        tmp = tmp->next;
    }
    CloseFile(cf);

    if (LOG) log("</SavePosition>\0");
}

void LoadPosition(int p)
{
    if (LOG) log("<LoadPosition>\0");

    int cf, size, vers_tmp, fb2a_tmp, fb2t_tmp;
    struct styles_tree *tmp;
    unsigned char no;
    cf = OpenFile(pos_filename);
    if (cf == 0)
    {
        Start(p);
    }
    else
    {
        ReadFile(cf, &vers_tmp, sizeof(int), &size);
        if (vers_tmp == version)
        {
            ReadFile(cf, &page[p].start, sizeof(long int), &size);
            ReadFile(cf, &page[p].line[0].flags, sizeof(unsigned char), &size);
            ReadFile(cf, &file_type, sizeof(unsigned char), &size);
            ReadFile(cf, &codepage, sizeof(unsigned char), &size);
            ReadFile(cf, &fd_size, sizeof(long int), &size);
            ReadFile(cf, &fb2a_tmp, sizeof(int), &size);
            ReadFile(cf, fb2_authors, fb2a_tmp, &size);
            ReadFile(cf, &fb2t_tmp, sizeof(int), &size);
            ReadFile(cf, fb2_title, fb2t_tmp, &size);
            ReadFile(cf, stat, sizeof(struct statistics), &size);

            ReadFile(cf, &no, sizeof(unsigned char), &size);
            while (size!=0)
            {
                tmp = calloc(sizeof(struct styles_tree));
                
                tmp->no = no;
                tmp->prev = curr_style;
                curr_style->next = tmp;
                curr_style = tmp;
                ReadFile(cf, &no, sizeof(unsigned char), &size);
            }
        }
        else
        {
            Start(p);
        }
        CloseFile(cf);
    }
    if (p==next_page)
    {
        page[curr_page].end = page[p].start;
        page[curr_page].num_lines = -1;
        page[curr_page].line[0].flags = page[p].line[0].flags;
    }

    if (LOG) log("</LoadPosition>\0");
}

void CountTimeStatistics()
{
    if (LOG) log("<CountTimeStatistics>\0");

    char year, month, day, hour, min, sec;
    long int turn_time_curr, turn_time_delta;

    GetLocalTime(&year, &month, &day, &hour, &min, &sec);
    if (year>99) year-=100;
    turn_time_curr = year*12*30*24*60*60+
    month*30*24*60*60+
    day*24*60*60+
    hour*60*60+
    min*60+
    sec;
    turn_time_delta = turn_time_curr - stat->time.turn_time_last;
    if (turn_time_delta<0) turn_time_delta = -turn_time_delta;
    if ((turn_time_delta>5)&&(turn_time_delta<120))
    {
        stat->time.read_time +=turn_time_delta;
        stat->time.read_time_all +=turn_time_delta;
        stat->time.read_counter+=1;
    }
    stat->time.turn_time_last = turn_time_curr;

    if (LOG) log("</CountTimeStatistics>\0");
}

void CountByteStatistics() {
    if (LOG) log("<CountByteStatistics>\0");

    long int turn_byte_delta;

    turn_byte_delta = page[curr_page].start - stat->byte.turn_byte_last;
    if (turn_byte_delta<0) turn_byte_delta = -turn_byte_delta;
    if ((turn_byte_delta>100)&&(turn_byte_delta<BUFF_SIZE))
    {
        stat->byte.read_byte += turn_byte_delta;
        stat->byte.read_counter+=1;
    }
    stat->byte.turn_byte_last = page[curr_page].start;

    if (LOG) log("</CountByteStatistics>\0");
}

void ResetStatistics()
{
    if (LOG) log("<ResetStatistics>\0");

    stat->time.turn_time_last = 0;
    stat->time.read_time = 0;
    stat->time.read_counter = 0;

    int pg_smbl;
    SetCurrFont(opt.profile[opt.profile_no].style[0].font_r);
    pg_smbl = out_area.width/GetCharWidth('n', curr_font->pointer);
    pg_smbl *= out_area.height/GetCharHeight('n', curr_font->pointer);

    stat->byte.turn_byte_last = 0;
    stat->byte.read_byte = pg_smbl;
    stat->byte.read_counter = 1;

    if (LOG) log("</ResetStatistics>\0");
}

void LoadNextPage()
{
    if (LOG) log("<LoadNextPage>\0");

    if (save_progress==0)
    {
        SavePosition();
        save_progress=opt.save_every;
    }
    page[next_page].start = page[curr_page].end;
    page[next_page].line[0].flags = page[curr_page].line[page[curr_page].num_lines+1].flags;
    LoadData(next_page, 0);
    ParseNextPage(next_page);

    if (LOG) log("</LoadNextPage>\0");
}

void TurnNextPage()
{
    if (LOG) log("<TurnNextPage>\0");

    if (prev_pos!=page[curr_page].start) prev_pos = page[curr_page].start;
    
    prev_page++;
    curr_page++;
    next_page++;
    if (prev_page == 3) prev_page = 0;
    if (curr_page == 3) curr_page = 0;
    if (next_page == 3) next_page = 0;

    CountTimeStatistics();
    CountByteStatistics();

    if (LOG) log("</TurnNextPage>\0");
}

void TurnPrevPage()
{
    if (LOG) log("<TurnPrevPage>\0");

    if (prev_page == 0)
    {
        prev_page = 2;
    }
    else
    {
        prev_page--;
    }
    if (curr_page == 0)
    {
        curr_page = 2;
    }
    else
    {
        curr_page--;
    }
    if (next_page == 0)
    {
        next_page = 2;
    }
    else
    {
        next_page--;
    }

    if (LOG) log("</TurnPrevPage>\0");
}

int ReadBuffer(long int pos)
{
    if (LOG) log("<ReadBuffer>\0");

    int size, read_size;
    memset(pagebuffer, 0, BUFF_SIZE*2);

    if ((fd_size-pos)<(BUFF_SIZE*2))
    {
        read_size = fd_size-pos;
    }
    else
    {
        read_size = BUFF_SIZE*2;
    }
    SeekFile(fd, pos, SEEK_SET);
    if (ReadFile(fd, pagebuffer, read_size, &size) != 0)
    {
        Alert("Error reading page", 1, 1);
        return 0;
    }

    if (LOG) log("</ReadBuffer>\0");
    return size;
}

void LoadTXT (int p, int size) 
{
    if (LOG) log("<LoadTXT>\0");

    int i=0, flag_space=0, flag_cr=0, count=0;
    unsigned char *cc=0;
    struct data_struct *res;

    unsigned char flags = page[p].line[0].flags;
    SetByte(&flags, PARAGRAF_END, NO); //not to mix
    SetByte(&flags, PARAGRAF_START, NO); //not to mix

    memset(data + p*BUFF_SIZE, 0, sizeof(struct data_struct)*BUFF_SIZE);

    res = data + p*BUFF_SIZE;
    cc = pagebuffer;
    for (i = 0; i<size; i++)
    {
        if ((*cc==SPACE)&&(flag_space==0))
        {
            res->symb = *cc;
            res->offset = i;
            res->flags = flags;
            res++;
            count++;
            flag_space = 1;
        }
        if ((*cc==CR)&&(flag_cr<2))
        {
            res->symb = 0;
            res->offset = i;
            res->flags = flags;
            SetByte(&(res-1)->flags, PARAGRAF_END, YES);
            SetByte(&(res+1)->flags, PARAGRAF_START, YES);
            res++;
            count++;
            flag_cr++;
        }
        if ((*cc!=SPACE)&&(*cc!=LF)&&(*cc!=CR))
        {
            res->symb = *cc;
            res->offset = i;
            res->flags = flags;
            res++;
            count++;
            flag_space = 0;
            flag_cr = 0;
        }
        if (count>=BUFF_SIZE) break;
        cc++;
    }

    if (LOG) log("</LoadTXT>\0");
}

void LoadFB2 (int p, int size)
{
    if (LOG) log("<LoadFB2>\0");

    int i=0, flag_space=0, flag_cr=0, count=0, temp=0;
    flag_cr=0;
    unsigned char *cc=0, *tag;
    unsigned char symb;
    struct data_struct *res;

    unsigned char flags = page[p].line[0].flags;
    SetByte(&flags, PARAGRAF_END, NO); //not to mix
    SetByte(&flags, PARAGRAF_START, NO); //not to mix

    int a=0, b=0, shift=1;

    memset(data + p*BUFF_SIZE, 0, sizeof(struct data_struct)*BUFF_SIZE);
    tag = calloc(16*sizeof(unsigned char));

    res = data + p*BUFF_SIZE;
    cc = pagebuffer;
    for (i = 0; i<size; i++)
    {
        if (codepage==1)
        {
            a = 0;
            b = 0;
            shift = 1;
            Decode1UTF8(cc, 3, &a, &b);
        }
        if (*cc==0) return;
        if (*cc=='<')
        {
            memset(tag, 0, 16);
            temp = DefineTag(cc, tag);
            cc += temp;
            i += temp;
            
            //Skip description
            if (WordsComp(tag, "description"))
            {
                while (!WordsComp(tag, "/description"))
                {
                    cc ++;
                    i ++;
                    if (*cc=='<')
                    {
                        memset(tag, 0, 16);
                        temp = DefineTag(cc, tag);
                        cc += temp;
                        i += temp;
                    }
                }
            }
            
            // Header style is ON
            if ((WordsComp(tag, "title"))
              ||(WordsComp(tag, "subtitle")))
            {
                curr_style->no = 1;
            }
            // Header style is OFF
            if ((WordsComp(tag, "/title"))
              ||(WordsComp(tag, "/subtitle")))
            {
                curr_style->no = 0;
            }
            
            // Italic is ON
            if ((WordsComp(tag, "emphasis"))
              ||(WordsComp(tag, "epigraph"))
              ||(WordsComp(tag, "stanza")))
            {
                SetByte(&flags, ITALIC, YES);
            }
            // Italic is OFF
            if ((WordsComp(tag, "/emphasis"))
              ||(WordsComp(tag, "/epigraph"))
              ||(WordsComp(tag, "/stanza")))
            {
                SetByte(&flags, ITALIC, NO);
            }

            // Bold is ON
            if ((WordsComp(tag, "text-author")) 
              ||(WordsComp(tag, "strong")))
            {
                SetByte(&flags, BOLD, YES);
            }
            // Bold is OFF
            if ((WordsComp(tag, "/text-author"))
              ||(WordsComp(tag, "/strong")))
            {
                SetByte(&flags, BOLD, NO);
            }

            // End of paragraph, or just empty line.
            if ((WordsComp(tag, "empty-line"))
              ||(WordsComp(tag, "title"))
              ||(WordsComp(tag, "/title"))
              ||(WordsComp(tag, "/subtitle"))
              ||(WordsComp(tag, "/v>"))
              ||(WordsComp(tag, "/p>")))
            {
                res->symb = 0;
                res->offset = i;
                res->flags = flags;
                res->style = curr_style->no;
                SetByte(&(res-1)->flags, PARAGRAF_END, YES);
                SetByte(&(res)->flags, PARAGRAF_END, YES);
                SetByte(&(res+1)->flags, PARAGRAF_START, YES);
                res++;
                count++;
                flag_space = 1;
            }
        }
        else
        {
            if ((*cc==SPACE)&&(flag_space==0)) // only one SPASE at a time
            {
                res->symb = *cc;
                res->offset = i;
                res->flags = flags;
                res->style = curr_style->no;
                res++;
                count++;
                flag_space = 1;
            }
            if ((*cc>SPACE) // if printable
              &&(*cc!='&')  // if not a &; code
              &&(*cc!='>')) // if not an end of a tag
            {
                res->symb = *cc;
                res->offset = i;
                res->flags = flags;
                res->style = curr_style->no;
                res++;
                count++;
                flag_space = 0;
            }
            if (*cc=='&') // if it is a &; code
            {
                temp=DefineCode(cc, &symb);
                if (temp)
                {
                    cc += temp;
                    i += temp;
                    res->symb = symb;
                    res->offset = i;
                    res->flags = flags;
                    res->style = curr_style->no;
                    res++;
                    count++;
                    flag_space = 0;
                }
            }
        }
        if (count>=BUFF_SIZE) break;
        
        // Update position if we are in UTF8
        if (a==2)
        {
            i++;
            shift = 2;
        }
        else if (a==3)
        {
            i+=2;
            shift = 3;
        }
        
        // Next symbol
        cc+=shift;
    }
    free(tag);
    tag=NULL;

    if (LOG) log("</LoadFB2>\0");
}

void LoadData(int p, unsigned char direction)
{
    if (LOG) log("<LoadData>\0");

    int size;
    size = ReadBuffer(page[p].start);

    if (size!=0)
    {
        if (file_type == 0) LoadTXT(p, size);
        if (file_type == 1) LoadFB2(p, size);
    }

    if (LOG) log("</LoadData>\0");
}
