#include "er.h"
#include "all_extern.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
//  : (*), (v), (c), (s), (-)
const unsigned char Symbol[256] =
{
    '*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
    '*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
    '*','*','*','*','*','*','*','*','*','*','*','*','*','-','*','*',
    '*','*','*','*','*','*','*','*','*','*','*','*','*','*','*','*',
    '*','v','c','c','c','v','c','c','c','v','c','c','c','c','c','v',
    'c','c','c','c','c','v','c','c','c','v','c','*','*','*','*','*',
    '*','v','c','c','c','c','c','c','c','v','c','c','c','c','c','v',
    'c','c','c','c','c','v','c','c','c','v','c','*','*','*','*','*',
    'c','c','*','c','*','*','*','*','*','*','c','*','c','c','c','c',
    'c','*','*','*','*','*','-','-','*','*','c','*','c','c','c','c',
    '*','c','c','c','*','c','*','*','v','*','v','*','*','-','*','v',
    '*','*','v','v','c','*','*','*','v','*','v','*','c','c','c','v',
    'v','c','c','c','c','v','c','c','v','s','c','c','c','c','v','c',
    'c','c','c','v','c','c','c','c','c','c','s','v','s','v','v','v',
    'v','c','c','c','c','v','c','c','v','s','c','c','c','c','v','c',
    'c','c','c','v','c','c','c','c','c','c','s','v','s','v','v','v'
};

// CP1251 ()   
const unsigned char UpLoCyr[256] =
{
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
    0x00,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x00,0x00,0x00,0x00,0x00,
    0x00,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,
    0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x00,0x00,0x00,0x00,0x00,
    0x90,0x83,0x00,0x83,0x00,0x00,0x00,0x00,0x00,0x00,0x9A,0x00,0x9C,0x9D,0x9E,0x9F,
    0x90,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x9A,0x00,0x9C,0x9D,0x9E,0x9F,
    0x00,0xA2,0xA2,0xBC,0x00,0xB4,0x00,0x00,0xB8,0x00,0xBA,0x00,0x00,0x00,0x00,0xBF,
    0x00,0x00,0xB3,0xB3,0xB4,0x00,0x00,0x00,0xB8,0x00,0xBA,0x00,0xBC,0xBE,0xBE,0xBF,
    0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
    0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF,
    0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
    0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF
};

//  (,,,, = 3),  (,,,,, = 2), (,,,,,,,,, = 1)
const unsigned char wSymb[256] =
{
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    4,2,2,2,4,2,2,2,4,2,2,2,2,2,4,2,2,2,2,2,4,2,2,2,4,2,
    5,5,5,5,5,5,
    4,2,2,2,2,2,2,2,4,2,2,2,2,2,4,2,2,2,2,2,4,2,2,2,4,2,
    5,5,5,5,5,5,5,5,5,5,
    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,5,
    5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,4,5,4,5,5,
    6,5,4,5,5,5,5,5,5,5,5,4,5,4,5,5,5,5,4,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,2,2,2,2,0,2,2,0,3,1,3,3,3,0,1,3,1,1,0,1,1,1,1,1,1,5,0,5,0,0,0
};
//////////////////////////////////////////////////////////////////////////////////////////////////

//==============================================================================
//        PalmFiction    Pascal  
void Hyphenate(struct data_struct *str, int *argStart, int *argPos, unsigned char *result)
{
    //============   ============
    // argStart -   
    // argPos -      "[]"
    //============   ============
    // argPos -        -1 ( ) "[]"
    // Result - True (1) -  , False (0) -  
    //====================================

    int k_1,k0,k1,k2,k3,k4,k5,k123,k23,k45,i1,i2,i3,i4,v12;
    int lead,tail;
    //     ,   
    int HypLead=opt.hyph_before_after,
    HypTail=opt.hyph_before_after;
    int i,n,start,fin,pos,hypPos,len;
    unsigned char u;

    //////////////////////////////////////////////////////////////////////////////////////////////////
    //  ,      
    int IHyphBufMax = 127;
    int IHyphBufCount = 136;
    int num[IHyphBufCount];
    unsigned char txt[IHyphBufCount];
    unsigned char ltr[IHyphBufCount];
    //////////////////////////////////////////////////////////////////////////////////////////////////

    *result=0;
    pos=*argPos;
    //  
    start=*argStart;
    for (i=pos;i>=0;i--)
    {
        u=(str+i)->symb;
        if (u<=32)
        {
            start=i+1;
            break;
        }
    }
    if (start>*argStart)
    {                        //      
        *argPos=start;       //     
    }
    else
    {                        //     
        *argPos=-1;          //      
        start=*argStart;     //   =  
    }

    //     
    if ((pos-start)<1) return;
    //  
    fin=pos;
    i=pos;
    u=(str+i)->symb;
    while (u>32)
    {
        i++;
        u=(str+i)->symb;
    }
    fin=i-1;
    //    3   
    if ((fin-start)<3) return;

    //   
    n=(fin-start+1)+8;
    if (n>IHyphBufCount) n=IHyphBufCount;
    for (i=0;i<n;i++) num[i]=*argPos;
    memset(&ltr[0],'*',n);
    memset(&txt[0],0,n);
    //.................
    hypPos=-1;
    n=0;
    for (i=start;i<=fin;i++)
    {
        num[n]=i;                           //   str
        txt[n]=(str+i)->symb;               //  str
        if ((hypPos<0)&&(i>=pos)) hypPos=n; //   
        n++;
        if (n==IHyphBufMax) return;
    }

    len=n;
    //-     
    if (hypPos>=(len-HypTail)) hypPos=len-HypTail-1;
    if (hypPos<(HypLead-1)) return;

    //
    //      .p  
    //   p,   "Serg Gera"   3744
    //

    //     "txt"     
    for (i=0;i<=len-1;i++)
    {
        u=txt[i];
        ltr[i]=Symbol[u];        //  (, )
        if (ltr[i]=='*')
        txt[i]=0;            // 
        else
        txt[i]=UpLoCyr[u];   //   
    }

    //   
    n=0;
    for (i=0;i<len;i++) if (ltr[i]=='v') n++;

    //      
    if (n<=1) return;

    //     
    lead=HypLead-1;
    tail=hypPos;

    //      
    for (i=0;i<len;i++)
    {
        if (ltr[i]=='v')
        {
            if (i>lead) lead=i;
            break;
        }
    }

    //      
    for (i=len-1;i>=0;i--)
    {
        if (ltr[i]=='v')
        {
            if ((i-1)<tail) tail=i-1;
            break;
        }
    }

    // - ,       ,  .
    //   "  " = 3, "  " = 3.
    //  "" = "-",  ,       
    //,    
    if (lead>tail) return;

    //...   ...........................................................
    for (i=tail;i>=lead;i--)
    {
        // hyphen
        if ((ltr[i]=='-')&&(i>(HypLead-1))) goto lab2;

        // s- ( ,,)
        if ((txt[i-1]==233)&&(wSymb[txt[i]]==1)&&(wSymb[txt[i+1]]>1)) goto lab1; //-, -,      "-"
        if ((ltr[i]=='s')&&(ltr[i-1]!='-')&&(ltr[i+1]!='-')&&(ltr[i+2]!='-')&&(!((txt[i]==233)&&(wSymb[txt[i+1]]==1)&&(wSymb[txt[i+2]]>1)))) goto lab1;

        // v-v
        if ((ltr[i]=='v')&&(ltr[i+1]=='v')&&(ltr[i+2]!='-')&&(ltr[i+2]!='*')&&(ltr[i-1]!='-')&&(ltr[i-1]!='*')) goto lab1;

        // vc-cv
        if ((ltr[i-1]=='v')&&(ltr[i]=='c')&&(ltr[i+1]=='c')&&(ltr[i+2]=='v'))
        {
            k4=txt[i]; // 
            k5=txt[i+1];
            if (k4==k5) goto lab1; //  
            k0=txt[i-4];
            k1=txt[i-3]<<2;
            k2=txt[i-2]<<5;
            k3=txt[i-1];
            if ((k2==0)&&((k3=238)||(k3=243))&&(k4=241)) continue; //,   -
            k5=k5<<5; // 
            k123=k1+k2+k3;
            k23=k2+k3;
            k45=k4+k5;
            //: ""  7886=239*32+238 ,  , , , ,  +228+235+236+240+247
            // 7591=231+230*32
            //: ""  7813=237*32+229 +   ,  "" ...230+237*32=7814
            //: ""  7808=237*32+224  , , ,  237,247,240,228,227
            // ? 237*32=7584(?   227,231,236)
            //: ""  7616=231*32+224 +  ,  ""228 ""236 //()
            //: ""  7950=241*32+238 + (),   247
            // 7527=231+228*32
            // 7531=235+228*32
            //- 7745=225+235*32
            //- 7984=240+242*32
            ////-  7824=240+237*32
            //?()  7584
            ////- 7809=225+237*32
            //: ()" k0=239, 8825=229*4+240*32+229   228
            //: "" 8874=239*4+240*32+238   +248  +225  +237  241  242*32 =7744 
            //: "" 8868=239*4+240*32+232   +237,  =
            //: "" 8865=239*4+240*32+229  "" +228  "?" 237*32=7584  +230
            //: ""  7483=226*32+251 +  ,  "()" ...248*32=7936
            //: " (-" 227+228*32
            //: ""  7816=237*32+232  242*32
            //: ""  7822=237*32+238  ? 7584
            //: "" 7534=228*32+238  241
            if (((k23==7886)&&(k4!=228)&&(k4!=235)&&(k4!=236)&&(k4!=240)&&(k4!=247)&&(k45!=7591)&&(k5!=7584))/**/
                    ||((k23==7808)&&(k4!=237)&&(k4!=228)&&(k4!=240)&&((k5!=7584)||((k5==7584)&&((k4==227)||(k4==231)||(k4==236)))))/**/
                    ||((k123==7616)&&(k4!=228)&&(k4!=236))/**/
                    ||((k123==7813)&&(k45!=7814))/**/
                    ||((k23==7950)&&(k4!=245)&&(k4!=247)&&(k45!=7527)&&(k45!=7531)&&(k45!=7745)&&(k45!=7984)&&(k5!=7584))/**/
                    ||((k123==8874)&&(k4!=247)&&(k4!=248)&&(k4!=225)&&(k4!=237)&&((k4!=241)&&(k5!=7744)))/**/
                    ||((k123==8868)&&(k4!=237)&&(k3!=224))/**/
                    ||((k123==8865)&&(k4!=228)&&(k4!=230)&&(k5!=7584))/**/
                    ||((k0==239)&&(k123==8825)&&(k4!=228))/**/
                    ||((k123==7483)&&(k5!=7936)) /**/
                    ||((k4==227)&&(k5==7296)) /**/ // ... -    
                    ||((k23==7534)&&(k4==241))/**/
                    ||((k23==7822)&&(k5!=7584))/**/
                    ||((k23==7816)&&(k5==7744))) i--;/**/
            goto lab1;
        }

        // cv-cv
        if ((ltr[i-1]=='c')&&(ltr[i]=='v')&&(ltr[i+1]=='c')&&(ltr[i+2]=='v')) goto lab1;

        // vc-ccv(c)  vcc-cv(c)
        if ((ltr[i-2]=='v')&&(ltr[i-1]=='c')&&(ltr[i]=='c')&&(ltr[i+1]=='c')&&((ltr[i+2]=='v')||(ltr[i+2]=='c')))
        {
            k_1=txt[i-4];
            k0=txt[i-3]<<5;
            k1=txt[i-2];
            i1=txt[i-1];
            i2=txt[i];
            i3=txt[i+1];
            i4=txt[i+2];
            if (ltr[i+2]=='v')
            { //     vcccv
                //: "" 7198=225*32+229-231
                //: "" 7658=239*32+238-221
                //: "" 7663=240*32+224-241  
                if (((k0+k1-i1)==7198)||((k0+k1-i1)==7658)||(((k0+k1-i1)==7663)&&(i3!=237)))
                {
                    i--;
                    goto lab1;
                }
                //: ""  7813=237*32+229 +  ,   240+226
                if (((k_1+k0+k1)==7813)&&(i1!=240)&&(i2!=226))
                {
                    i-=2;
                    goto lab1;
                }
                //: ""  7886=239*32+238  , ,  -235-240-231+228
                if (((k0+k1)==7886)&&(i1!=235)&&(i1!=240)&&(i1!=231)&&(i2!=228))
                {
                    i=i-2;
                    goto lab1;
                }
            }
            v12=100*wSymb[i1]+10*wSymb[i2]+wSymb[i3]; //  123
            //[]=3
            //[]=2
            //[]=1
            if ((v12==321)||
                    (v12==333)||
                    (v12==331)|| //-
                    (v12==312)|| //-
                    (v12==221)|| //-
                    (i3==237)||  //??-()
                    (i2==242)||  //?()-? -
                    ((i3==241)&&(i4==242))|| //??-()? -
                    ((v12==111)&&(i1==234)&&(i2 = 241))|| //-
                    ((i1==241)&&(i2==242))|| //()-
                    (v12==332))
            {
                goto lab1;   //**-*
            }
            else
            {
                i--;
                goto lab1;
            }
        }

        // vc-csv (-)
        if ((ltr[i-1]=='v')&&(ltr[i]=='c')&&(ltr[i+1]=='c')&&(ltr[i+2]=='s')&&(ltr[i+3]=='v')) goto lab1;

        // cv-csv (-)  -
        if ((ltr[i-1]=='c')&&(ltr[i]=='v')&&(ltr[i+1]=='c')&&(txt[i+2]==252)&&(ltr[i+3]=='v')) goto lab1;

    } // 

    return;                   //,   

lab1:                  //    
    if (i<lead) return;  //  ,      
    *result=1;           //   

lab2:                        //     ,   ..
    *argPos=num[i+1];          //    (    )
    if (*argPos==*argStart)
    {  //    
        *argPos=-1;              // 
        *result=0;               //    
    }
    return;
}
//==============================================================================


void ParsePrevPage(int p)
{

}

void ParseNextPage(int p)
{
    if (LOG) log("<ParseNextPage>\0");

    int sum_x, sum_y;
    int font_b, font_i;
    int offset, count, space, hyph_shift=0, hyph_start=0;
    int i, j;
    unsigned char max_h, max_asc;
    unsigned char cwidth, hyph_symb=0;
    struct data_struct *cc;

    long int tmp_pos = page[p].start;
    unsigned char tmp_flags = page[p].line[0].flags;
    memset(&page[p], 0, sizeof(struct pages));
    page[p].start = tmp_pos;
    page[p].line[0].flags = tmp_flags;
    //  the only page[p].start is given at the beginning

    offset = 0;
    sum_y = 0;
    i = 0;
    cc = (data + p*BUFF_SIZE);

    while (cc->symb == 0) 
    {
        offset++;
        cc++;
    } // no empty lines at the top of page

        while (1) 
    {
        count = 0;
        space = 0;
        sum_x = 0;
        max_h = 0;
        max_asc = 0;

        while (cc->symb == 32) 
        {
            offset++;
            cc++;
        } // no leading spases
        page[p].line[i].offset = offset;

        SetCurrFont(opt.profile[opt.profile_no].style[0].font_r);
        if ((GetByte(&cc->flags, PARAGRAF_START)==YES)||
                (GetByte(&page[p].line[i].flags, PARAGRAF_START)==YES)) 
        {
            SetByte(&page[p].line[i].flags, PARAGRAF_START, YES);
            cwidth = GetCharWidth(' ', curr_font->pointer);
            sum_x += cwidth*opt.profile[opt.profile_no].style[cc->style].paragraph.indent;
        }

        while (1) 
        {
            page[p].line[i].flags |= cc->flags;
            font_b = GetByte(&cc->flags, BOLD);
            font_i = GetByte(&cc->flags, ITALIC);
            if ((font_b==YES)&&(font_i==YES)) SetCurrFont(opt.profile[opt.profile_no].style[cc->style].font_bi);
            if ((font_b==YES)&&(font_i==NO)) SetCurrFont(opt.profile[opt.profile_no].style[cc->style].font_b);
            if ((font_b==NO)&&(font_i==YES)) SetCurrFont(opt.profile[opt.profile_no].style[cc->style].font_i);
            if ((font_b==NO)&&(font_i==NO)) SetCurrFont(opt.profile[opt.profile_no].style[cc->style].font_r);

            if (cc->symb == 0) 
            {
                offset++;
                cc++;
                SetByte(&page[p].line[i].flags, PARAGRAF_END, YES);
                SetByte(&page[p].line[i+1].flags, PARAGRAF_START, YES);
                break;
            }

            cwidth = GetCharWidth(cc->symb, curr_font->pointer);
            if (sum_x+cwidth > out_area.width) 
            {
                SetByte(&page[p].line[i].flags, PARAGRAF_END, NO);
                break;
            }

            if (max_h<curr_font->height) max_h = curr_font->height;
            if (max_asc<curr_font->ascent) max_asc = curr_font->ascent;
            if (cc->symb == 32) space++;
            sum_x += cwidth;
            count++;
            offset++;
            cc++;
        }

        SetByte(&page[p].line[i].flags, HYPH, NO);
        if (GetByte(&page[p].line[i].flags,PARAGRAF_END)==NO) 
        {
            switch (cc->symb) 
            {
            case 0: 
                SetByte(&page[p].line[i].flags, PARAGRAF_END, YES);
                SetByte(&page[p].line[i+1].flags, PARAGRAF_START, YES);
                offset++;
                cc++;
                break;
                
            case 32: 
                break;
                
            default: 
                if (space!=0) 
                {
                    hyph_start = 0;
                    hyph_shift = 0;
                    hyph_symb=0;
                    while ((cc->symb != 32)&&(cc->symb != 0)) 
                    {
                        cc--;
                        count--;
                        offset--;
                        hyph_shift++;
                        cwidth = GetCharWidth(cc->symb, curr_font->pointer);
                        sum_x -= cwidth;
                    }
                    space--;
                    if (opt.profile[opt.profile_no].style[cc->style].paragraph.hyphenation==1) 
                    {
                        cwidth = GetCharWidth('-', curr_font->pointer);
                        hyph_shift--; // try to avoid delta<0 in PrintLine
                        Hyphenate(cc, &hyph_start, &hyph_shift, &hyph_symb);
                        if ((hyph_shift==1)&&(cc->symb==32)) hyph_shift=0;
                        if (hyph_shift>0) 
                        {
                            if (hyph_symb) SetByte(&page[p].line[i].flags, HYPH, YES);
                            sum_x += cwidth;
                            for(j=0;j<hyph_shift;j++) 
                            {
                                cwidth = GetCharWidth(cc->symb, curr_font->pointer);
                                sum_x += cwidth;
                                count++;
                                cc++;
                            }
                        }
                        offset+=hyph_shift;
                    }
                }
            }
        }

        page[p].line[i].count = count;
        page[p].line[i].space = space;
        page[p].line[i].width = sum_x;

        if (max_h == 0) max_h = curr_font->height;
        if (max_asc == 0) max_asc = curr_font->ascent;

        if (GetByte(&page[p].line[i].flags,PARAGRAF_END)==YES)
            max_h += opt.profile[opt.profile_no].style[cc->style].paragraph.paragraph_spacing;
        
        max_h += opt.profile[opt.profile_no].style[cc->style].paragraph.line_spacing;

        if (max_h < 12) max_h = 12;
        
        page[p].line[i].height = max_h;
        page[p].line[i].ascent = max_asc;

        sum_y += max_h;
        if (sum_y>out_area.height) break;
        i++;
    }

    i-=1;
    page[p].end = page[p].start + (data + p*BUFF_SIZE + page[p].line[i].offset + page[p].line[i].count)->offset;
    page[p].num_lines = i;

    if (LOG) log("</ParseNextPage>\0");
}

int PrintLine(int p, int i, int y) 
{
    int j, x, delta, space, tmp=0, font_i, font_b, style_no;
    unsigned char cwidth;
    char cc[2];

    cc[1] = 0;

    cc[0] = (data + p*BUFF_SIZE + page[p].line[i].offset)->symb;
    style_no = (data + p*BUFF_SIZE + page[p].line[i].offset)->style;

    SetCurrFont(opt.profile[opt.profile_no].style[style_no].font_r);

    x = out_area.x;

    delta = out_area.width - page[p].line[i].width;
    
    if (opt.profile[opt.profile_no].style[style_no].paragraph.alignment == 1) x+=delta;
    if (opt.profile[opt.profile_no].style[style_no].paragraph.alignment == 2) x+=delta/2;

    y -= page[p].line[i].height;
    space = page[p].line[i].space;

    if (GetByte(&page[p].line[i].flags, PARAGRAF_START)==YES) 
    {
        cwidth = GetCharWidth(' ', curr_font->pointer);
        for (j=0; j<opt.profile[opt.profile_no].style[style_no].paragraph.indent; j++) 
        {
            Print(EINK, x, y, " ", curr_font->pointer);
            x += cwidth;
        }
    }

    for (j=0;j<page[p].line[i].count;j++) 
    {
        cc[0] = (data + p*BUFF_SIZE + page[p].line[i].offset + j)->symb;
        style_no = (data + p*BUFF_SIZE + page[p].line[i].offset + j)->style;

        font_b = GetByte(&(data + p*BUFF_SIZE + page[p].line[i].offset + j)->flags, BOLD);
        font_i = GetByte(&(data + p*BUFF_SIZE + page[p].line[i].offset + j)->flags, ITALIC);
        if ((font_b==YES)&&(font_i==YES)) SetCurrFont(opt.profile[opt.profile_no].style[style_no].font_bi);
        if ((font_b==YES)&&(font_i==NO)) SetCurrFont(opt.profile[opt.profile_no].style[style_no].font_b);
        if ((font_b==NO)&&(font_i==YES)) SetCurrFont(opt.profile[opt.profile_no].style[style_no].font_i);
        if ((font_b==NO)&&(font_i==NO)) SetCurrFont(opt.profile[opt.profile_no].style[style_no].font_r);

        Print(EINK, x, y, &cc[0], curr_font->pointer);
        cwidth = GetCharWidth(cc[0], curr_font->pointer);
        x += cwidth;

        if (opt.profile[opt.profile_no].style[style_no].paragraph.alignment == 3) 
        {
            if ((cc[0] == 32)&&(space != 0)&&
                    (GetByte(&page[p].line[i].flags,PARAGRAF_END)==NO)) 
            {
                if (space == 1) tmp = delta;
                else tmp = delta/space;
                x += tmp;
                delta -= tmp;
                space --;
            }
        }
    }
    if (GetByte(&page[p].line[i].flags, HYPH)==YES)
    Print(EINK, x, y, "-", curr_font->pointer);
    return page[p].line[i].height;
}

void ShowProgressBar1(long int curpos) 
{
    if (LOG) log("<ProgressBar1>\0");

    char buf[20];
    char hour, min;
    int prgrs_1=0, prgrs_2=0, i;
    long int proc_xx, proc_y; // xx.yy
    long int rest_time;
    int sbar_x=0, sbar_y=0, sbar_x2=0, sbar_y2=0, pg_smbl, height;
    unsigned char pow;

    pg_smbl = stat->byte.read_byte/stat->byte.read_counter;

    // count required font height
    SetCurrFont(opt.statusbar_t.font);
    height = curr_font->height;

    // count progress
    if ((opt.statusbar_t.progress!=0)||(opt.statusbar_t.style!=0)) 
    {
        proc_xx = fd_size/100;
        if (proc_xx == 0) proc_xx = 1;
        proc_y = fd_size/10000;
        if (proc_y == 0) proc_y = 1;

        prgrs_1 = curpos/proc_xx;
        i = curpos - prgrs_1*proc_xx;
        prgrs_2 = i/proc_y;
    }

    // time
    if ((opt.statusbar_t.info==5)&&(opt.statusbar_t.time>0)&&(file_type==1)) 
    {
        // that means there will be two lines, time-info is plased to the second
        sbar_x2 = 0;
        sbar_y2 = height;
    }
    if ((opt.statusbar_t.time==1)||(opt.statusbar_t.time==2)||(opt.statusbar_t.time==3)) 
    {
        GetLocalTime(NULL, NULL, NULL, &hour, &min, NULL);
        sprintf(buf, "[%i:%02i]", hour, min);
        sbar_x2 += GetStringWidth(buf, curr_font->pointer)+4;
        Print(EINK, out_area.max_width - sbar_x2, sbar_y2 + curr_font->ascent, buf, curr_font->pointer);
    }
    if ((opt.statusbar_t.time==2)||(opt.statusbar_t.time==3)||
            (opt.statusbar_t.time==4)||(opt.statusbar_t.time==5)) 
    {
        if (stat->time.read_counter>3) 
        {
            rest_time = (stat->time.read_time/stat->time.read_counter)*
            ((fd_size-curpos)/pg_smbl);
            hour = rest_time/3600;
            min = (rest_time - (rest_time/3600)*3600)/60;
            sprintf(buf, "~%-02i:%-02i", hour, min);
        } 
        else 
        {
            sprintf(buf, "--:--");
        }
        sbar_x2 += GetStringWidth(buf, curr_font->pointer)+4;
        Print(EINK, out_area.max_width - sbar_x2, sbar_y2 + curr_font->ascent, buf, curr_font->pointer);
    }
    if ((opt.statusbar_t.time==3)||(opt.statusbar_t.time==4)) 
    {
        hour = stat->time.read_time_all/3600;
        min = (stat->time.read_time_all - (stat->time.read_time_all/3600)*3600)/60;
        sprintf(buf, "%-02i:%-02i/", hour, min);
        sbar_x2 += GetStringWidth(buf, curr_font->pointer);
        Print(EINK, out_area.max_width - sbar_x2, sbar_y2 + curr_font->ascent, buf, curr_font->pointer);
    }
    if (((opt.statusbar_t.info!=5)&&(opt.statusbar_t.time>0))||(file_type==0)) 
    {
        // that means there will be only one line
        sbar_x = sbar_x2;
    }
    // progress in 'pages'
    if ((opt.statusbar_t.progress == 2)||(opt.statusbar_t.progress == 3)) 
    {
        sprintf(buf, "%i/~%i", curpos/pg_smbl, fd_size/pg_smbl);
        if (sbar_x==0) 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
        } 
        else 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+12;
        }
        Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
    }

    // progress in %,%%
    if ((opt.statusbar_t.progress == 1)||(opt.statusbar_t.progress == 3)) 
    {
        sprintf(buf, "%i.%-02i%%", prgrs_1, prgrs_2);
        if (((opt.statusbar_t.time==0)||(sbar_x==0))&&(opt.statusbar_t.progress==1)) 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
        } 
        else 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+12;
        }
        Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
    }

    // show horizontal icon for battery
    if ((opt.statusbar_t.battery == 2)||(opt.statusbar_t.battery == 4)) 
    {
        if (height<24) height = 24;
        if (sbar_x==0) 
            sbar_x += 52+4;
        else 
            sbar_x += 52+12;
        
        DrawHBattary(EINK, out_area.max_width - sbar_x, sbar_y);
    }

    // show vertical icon for battery
    if ((opt.statusbar_t.battery == 3)||(opt.statusbar_t.battery == 5)) 
    {
        if (sbar_x==0) 
            sbar_x += 16+4;
        else 
            sbar_x += 16+12;
        if (height<24) height = 24;

        DrawVBattary(EINK, out_area.max_width - sbar_x, sbar_y);
    }

    // show the power in %
    if ((opt.statusbar_t.battery == 1)||(opt.statusbar_t.battery == 4)||(opt.statusbar_t.battery == 5)) 
    {
        i = GetSysState();
        if ((i&0x0001)==1) 
        {
            sprintf(buf, "XX%%");
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
            Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
        } 
        else 
        {
            pow = *GetBatteryPower();
            sprintf(buf, "%i%%", pow);
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
            Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
        }
    }

    if ((opt.statusbar_t.info!=0)||
            (opt.statusbar_t.progress!=0)||
            (opt.statusbar_t.time!=0)||
            (opt.statusbar_t.battery!=0))
    sbar_y = height;

    // file info
    if ((opt.statusbar_t.info==1)||
            ((opt.statusbar_t.info>1)&&(file_type==0))) 
        TextOutCenter(EINK, 4, 0, out_area.max_width-sbar_x-12, sbar_y, 1, 1, title);
    if ((opt.statusbar_t.info==2)&&(file_type==1)) 
        TextOutCenter(EINK, 4, 0, out_area.max_width-sbar_x-12, sbar_y, 1, 1, fb2_authors);
    if ((opt.statusbar_t.info==3)&&(file_type==1)) 
        TextOutCenter(EINK, 4, 0, out_area.max_width-sbar_x-12, sbar_y, 1, 1, fb2_title);
    if ((opt.statusbar_t.info==4)&&(file_type==1)) 
    {
        char bigbuf[512];
        sprintf(bigbuf, "%s, %s", fb2_authors, fb2_title);
        TextOutCenter(EINK, 4, 0, out_area.max_width-sbar_x-12, sbar_y, 1, 1, bigbuf);
    }
    if ((opt.statusbar_t.info==5)&&(file_type==1)) 
    {
        TextOutCenter(EINK, 4, 0, out_area.max_width-sbar_x-12, sbar_y, 1, 1, fb2_authors);
        TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x2-12, sbar_y, 1, 1, fb2_title);
        sbar_y*=2;
    }
    if ((opt.statusbar_t.info==6)&&(file_type==1)) 
    {
        int page_odd;
        page_odd = (curpos/pg_smbl)&1;
        if (page_odd==0) TextOutCenter(EINK, 4, 0, out_area.max_width-sbar_x-12, sbar_y, 1, 1, fb2_authors);
        if (page_odd==1) TextOutCenter(EINK, 4, 0, out_area.max_width-sbar_x-12, sbar_y, 1, 1, fb2_title);
    }

    if ((opt.statusbar_t.style!=0)&&(sbar_y==0)) sbar_y = 2;
    // progress bar - simple thin line
    if (opt.statusbar_t.style == 1) 
    {
        DrawHLine(EINK, 5, sbar_y+1, out_area.max_width - 10, 0);
        DrawHLine(EINK, 5, sbar_y+2, prgrs_1*(out_area.max_width-10)/100, 1);
        DrawHLine(EINK, 5, sbar_y+3, out_area.max_width - 10, 0);
        sbar_y += 6;
    }
    // progress bar - simple thick line
    if (opt.statusbar_t.style == 2) 
    {
        DrawHLine(EINK, 5, sbar_y+1, out_area.max_width - 10, 1);
        DrawHLine(EINK, 5, sbar_y+2, out_area.max_width - 10, 3);
        DrawHLine(EINK, 5, sbar_y+3, out_area.max_width - 10, 2);
        DrawHLine(EINK, 5, sbar_y+4, out_area.max_width - 10, 1);
        DrawHLine(EINK, 5, sbar_y+5, out_area.max_width - 10, 0);
        DrawHLine(EINK, 5, sbar_y+1, prgrs_1*(out_area.max_width-10)/100, 1);
        DrawHLine(EINK, 5, sbar_y+2, prgrs_1*(out_area.max_width-10)/100, 2);
        DrawHLine(EINK, 5, sbar_y+3, prgrs_1*(out_area.max_width-10)/100, 1);
        DrawHLine(EINK, 5, sbar_y+4, prgrs_1*(out_area.max_width-10)/100, 0);
        DrawHLine(EINK, 5, sbar_y+5, prgrs_1*(out_area.max_width-10)/100, 0);
        sbar_y += 8;
    }
    // progress bar - graphical
    if (opt.statusbar_t.style == 3) 
    {
        for (i = 4; i < prgrs_1*(out_area.max_width-8)/100+4; i+=4) 
            DrawImageResource(EINK, i, sbar_y, "PROGRESS01");
        for (i = prgrs_1*(out_area.max_width-8)/100+4; i<= out_area.max_width-8; i+=4) 
            DrawImageResource(EINK, i, sbar_y, "PROGRESS02");
        sbar_y += 8;
    }
    // progress bar - simple thin line without progress
    if (opt.statusbar_t.style == 4)
    {
        //    DrawHLine(EINK, 5, sbar_y, out_area.max_width - 10, 0);
        DrawHLine(EINK, 5, sbar_y+1, out_area.max_width - 10, 0);
        DrawHLine(EINK, 5, sbar_y+2, out_area.max_width - 10, 0);
        sbar_y += 5;
    }

    // and finally - Color Schema
    switch (opt.statusbar_t.color) 
    {
    case 0: 
        break;
    case 1: 
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 1, AND);
        break;
    case 2: 
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 2, AND);
        break;
    case 3: 
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 2, SET);
        break;
    case 4: 
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 1, SET);
        break;
    case 5: 
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 2, AND);
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 1, OR);
        break;
    case 6: 
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 1, AND);
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 2, OR);
        break;
    case 7: 
        FillArea(EINK, 0, 0, out_area.max_width, sbar_y, 3, OR);
        break;
    }

    if ((opt.statusbar_t.visible==0)||(opt.page.fullscr==1)) 
        opt.statusbar_t.height = 0;
    else 
        opt.statusbar_t.height = sbar_y;
        
    if (LOG) log("</ProgressBar1>\0");
}

void ShowProgressBar2(long int curpos)
{
    if (LOG) log("<ProgressBar2>\0");

    char buf[20];
    int prgrs_1=0, prgrs_2=0, i;
    char hour, min;
    long int proc_xx, proc_y; // xx.yy
    long int rest_time;
    int sbar_x=0, sbar_y=out_area.max_height, sbar_x2=0, sbar_y2=out_area.max_height, pg_smbl, height;
    unsigned char pow;

    pg_smbl = stat->byte.read_byte/stat->byte.read_counter;

    // count required font height
    SetCurrFont(opt.statusbar_b.font);
    height = curr_font->height;

    if (((opt.statusbar_b.battery==2)||(opt.statusbar_b.battery==3)||(opt.statusbar_b.battery==4)
                ||(opt.statusbar_b.battery==5))&&(height<24)) height = 24;

    if ((opt.statusbar_b.info!=0)||(opt.statusbar_b.progress!=0)||(opt.statusbar_b.time!=0)||
            (opt.statusbar_b.battery!=0)) sbar_y -= height;

    // count progress
    if ((opt.statusbar_b.progress!=0)||(opt.statusbar_b.style!=0))
    {
        proc_xx = fd_size/100;
        if (proc_xx == 0) proc_xx = 1;
        proc_y = fd_size/10000;
        if (proc_y == 0) proc_y = 1;

        prgrs_1 = curpos/proc_xx;
        i = curpos - prgrs_1*proc_xx;
        prgrs_2 = i/proc_y;
    }

    // time
    sbar_y2 = sbar_y;
    if ((opt.statusbar_b.info==5)&&(opt.statusbar_b.time>0)&&(file_type==1))
    {
        // that means there will be two lines, time-info is plased to the first
        sbar_x2 = 0;
        sbar_y2-= height;
    }
    if ((opt.statusbar_b.time==1)||
            (opt.statusbar_b.time==2)||
            (opt.statusbar_b.time==3))
    {
        GetLocalTime(NULL, NULL, NULL, &hour, &min, NULL);
        sprintf(buf, "[%i:%02i]", hour, min);
        sbar_x2 += GetStringWidth(buf, curr_font->pointer)+4;
        Print(EINK, out_area.max_width - sbar_x2, sbar_y2 + curr_font->ascent, buf, curr_font->pointer);
    }
    if ((opt.statusbar_b.time==2)||
            (opt.statusbar_b.time==3)||
            (opt.statusbar_b.time==4)||
            (opt.statusbar_b.time==5))
    {
        if (stat->time.read_counter>3)
        {
            rest_time = (stat->time.read_time/stat->time.read_counter)*
            ((fd_size-curpos)/pg_smbl);
            hour = rest_time/3600;
            min = (rest_time - (rest_time/3600)*3600)/60;
            sprintf(buf, "~%-02i:%-02i", hour, min);
        }
        else
        {
            sprintf(buf, "--:--");
        }
        sbar_x2 += GetStringWidth(buf, curr_font->pointer)+4;
        Print(EINK, out_area.max_width - sbar_x2, sbar_y2 + curr_font->ascent, buf, curr_font->pointer);
    }
    if ((opt.statusbar_b.time==3)||
            (opt.statusbar_b.time==4))
    {
        hour = stat->time.read_time_all/3600;
        min = (stat->time.read_time - (stat->time.read_time_all/3600)*3600)/60;
        sprintf(buf, "%-02i:%-02i/", hour, min);
        sbar_x2 += GetStringWidth(buf, curr_font->pointer);
        Print(EINK, out_area.max_width - sbar_x2, sbar_y2 + curr_font->ascent, buf, curr_font->pointer);
    }
    if (((opt.statusbar_b.info!=5)&&(opt.statusbar_b.time>0))||(file_type==0))
    {
        // that means there will be only one line
        sbar_x = sbar_x2;
    }

    // progress in 'pages'
    if ((opt.statusbar_b.progress == 2)||(opt.statusbar_b.progress == 3))
    {
        sprintf(buf, "%i/~%i", curpos/pg_smbl, fd_size/pg_smbl);
        if (sbar_x==0) 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
        } 
        else 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+12;
        }
            
        Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
    }

    // progress in %,%%
    if ((opt.statusbar_b.progress == 1)||(opt.statusbar_b.progress == 3))
    {
        sprintf(buf, "%i.%-02i%%", prgrs_1, prgrs_2);
        if (((opt.statusbar_b.time==0)||(sbar_x==0))&&(opt.statusbar_b.progress==1)) 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
        } 
        else 
        {
            sbar_x += GetStringWidth(buf, curr_font->pointer)+12;
        }
        Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
    }

    // show horizontal icon for battery
    if ((opt.statusbar_b.battery == 2)||(opt.statusbar_b.battery == 4))
    {
        if (sbar_x==0)
            sbar_x += 52+4;
        else
            sbar_x += 52+12;

        DrawHBattary(EINK, out_area.max_width - sbar_x, sbar_y);
    }

    // show vertical icon for battery
    if ((opt.statusbar_b.battery == 3)||(opt.statusbar_b.battery == 5))
    {
        if (sbar_x==0)
            sbar_x += 16+4;
        else
            sbar_x += 16+12;
            
        DrawVBattary(EINK, out_area.max_width - sbar_x, sbar_y);
    }

    // show the power in %
    if ((opt.statusbar_b.battery == 1)||(opt.statusbar_b.battery == 4)||(opt.statusbar_b.battery == 5))
    {
        i = GetSysState();
        if ((i&0x0001)==1)
        {
            sprintf(buf, "XX%%");
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
            Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
        }
        else
        {
            pow = *GetBatteryPower();
            sprintf(buf, "%i%%", pow);
            sbar_x += GetStringWidth(buf, curr_font->pointer)+4;
            Print(EINK, out_area.max_width - sbar_x, sbar_y + curr_font->ascent, buf, curr_font->pointer);
        }
    }

    // file info
    if ((opt.statusbar_b.info==1)||
            ((opt.statusbar_b.info>1)&&(file_type==0)))
        TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x-12, height, 1, 1, title);
    if ((opt.statusbar_b.info==2)&&(file_type==1))
        TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x-12, height, 1, 1, fb2_authors);
    if ((opt.statusbar_b.info==3)&&(file_type==1))
        TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x-12, height, 1, 1, fb2_title);
    if ((opt.statusbar_b.info==4)&&(file_type==1))
    {
        char bigbuf[512];
        sprintf(bigbuf, "%s, %s", fb2_authors, fb2_title);
        TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x-12, height, 1, 1, bigbuf);
    }
    if ((opt.statusbar_b.info==5)&&(file_type==1))
    {
        TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x-12, height, 1, 1, fb2_title);
        TextOutCenter(EINK, 4, sbar_y-height, out_area.max_width-sbar_x2-12, height, 1, 1, fb2_authors);
        height*=2;
        sbar_y = out_area.max_height-height;
    }
    if ((opt.statusbar_b.info==6)&&(file_type==1))
    {
        int page_odd;
        page_odd = (curpos/pg_smbl)&1;
        if (page_odd==0) TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x-12, height, 1, 1, fb2_authors);
        if (page_odd==1) TextOutCenter(EINK, 4, sbar_y, out_area.max_width-sbar_x-12, height, 1, 1, fb2_title);
    }

    if ((opt.statusbar_b.style!=0)&&(sbar_y==out_area.max_height))
    {
        height = 2;
        sbar_y = out_area.max_height-height;
    }
    // progress bar - simple thin line
    if (opt.statusbar_b.style == 1)
    {
        DrawHLine(EINK, 5, sbar_y-2, out_area.max_width - 10, 0);
        DrawHLine(EINK, 5, sbar_y-1, prgrs_1*(out_area.max_width-10)/100, 1);
        DrawHLine(EINK, 5, sbar_y, out_area.max_width - 10, 0);
        height += 3;
    }
    // progress bar - simple thick line
    if (opt.statusbar_b.style == 2)
    {
        DrawHLine(EINK, 5, sbar_y-6, out_area.max_width - 10, 1);
        DrawHLine(EINK, 5, sbar_y-5, out_area.max_width - 10, 3);
        DrawHLine(EINK, 5, sbar_y-4, out_area.max_width - 10, 2);
        DrawHLine(EINK, 5, sbar_y-3, out_area.max_width - 10, 1);
        DrawHLine(EINK, 5, sbar_y-2, out_area.max_width - 10, 0);
        DrawHLine(EINK, 5, sbar_y-6, prgrs_1*(out_area.max_width-10)/100, 1);
        DrawHLine(EINK, 5, sbar_y-5, prgrs_1*(out_area.max_width-10)/100, 2);
        DrawHLine(EINK, 5, sbar_y-4, prgrs_1*(out_area.max_width-10)/100, 1);
        DrawHLine(EINK, 5, sbar_y-3, prgrs_1*(out_area.max_width-10)/100, 0);
        DrawHLine(EINK, 5, sbar_y-2, prgrs_1*(out_area.max_width-10)/100, 0);
        height += 6;
    }
    // progress bar - graphical
    if (opt.statusbar_b.style == 3)
    {
        for (i = 4; i < prgrs_1*(out_area.max_width-8)/100+4; i+=4)
            DrawImageResource(EINK, i, sbar_y-4, "PROGRESS01");
        for (i = prgrs_1*(out_area.max_width-8)/100+4; i<= out_area.max_width-8; i+=4)
            DrawImageResource(EINK, i, sbar_y-4, "PROGRESS02");
        height += 5;
    }
    // progress bar - simple thin line without progress
    if (opt.statusbar_b.style == 4)
    {
        DrawHLine(EINK, 5, sbar_y-3, out_area.max_width - 10, 0);
        DrawHLine(EINK, 5, sbar_y-2, out_area.max_width - 10, 0);
        height += 3;
    }

    // and finally - Color Schema
    if (opt.statusbar_b.visible==1) height+=2;
    sbar_y = out_area.max_height-height;

    switch (opt.statusbar_b.color)
    {
    case 0:
        break;
    case 1:
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 1, AND);
        break;
    case 2:
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 2, AND);
        break;
    case 3:
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 2, SET);
        break;
    case 4:
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 1, SET);
        break;
    case 5:
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 2, AND);
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 1, OR);
        break;
    case 6:
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 1, AND);
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 2, OR);
        break;
    case 7:
        FillArea(EINK, 0, sbar_y, out_area.max_width, height, 3, OR);
        break;
    }

    if ((opt.statusbar_b.visible==0)||(opt.page.fullscr==1))
        opt.statusbar_b.height = 0;
    else
        opt.statusbar_b.height = height;

    if (LOG) log("</ProgressBar2>\0");
}

void PaintPage(int p)
{
    if (LOG) log("<PaintPage>\0");

    int i, y, delta, tmp, num_lines;

    ClearWindow(EINK);

    delta = 0;
    for (i=0; i <= page[p].num_lines; i++) delta += page[p].line[i].height;

    delta = out_area.height - delta;
    y = out_area.y + out_area.height;

    if (opt.page.alignment == 1) y -= delta;
    if (opt.page.alignment == 3) y -= delta/2;

    num_lines = page[p].num_lines+1;
    for (i=page[p].num_lines; i >= 0; i--)
    {
        y -= PrintLine(p, i, y+page[p].line[i].ascent);
        if (opt.page.alignment == 0)
        {
            if (i == 1) tmp = delta;
            else tmp = delta/num_lines;
            y -= tmp;
            delta -= tmp;
            num_lines--;
        }
    }
    if ((opt.statusbar_t.visible==1)&&(opt.page.fullscr==0)) ShowProgressBar1(page[p].start);
    if ((opt.statusbar_b.visible==1)&&(opt.page.fullscr==0)) ShowProgressBar2(page[p].start);

    if ((opt.page.layout == 2)||(opt.page.layout == 3)) RotateScreen();

    if (LOG) log("</PaintPage>\0");
}
