#include "lock.h"

int logocount, lf, pics_no;
char *logoname;

struct pic_struct {
  unsigned int offset;
  unsigned char name[32];
} *pics[60];


void Lock_Paint()
{
    if ((opt.page.layout==1)||(opt.page.layout==3)) SetLayout(EINK, 0);
    
    FilesCount();
    if (logocount==0) 
    {
        DrawLOGO();
        return;
    }
    
    logoname = calloc(256);
    
    char rnd_file, rnd_pic;
    GetLocalTime(NULL, NULL, NULL, NULL, &rnd_file, &rnd_pic);
    
    rnd_file = rnd_file - (rnd_file/logocount)*logocount + 1;
    lf = Open_FileNo(rnd_file);
    if (lf==0) 
    {
        DrawLOGO();
        return;
    }

    Load_PicsHeader();
    rnd_pic = rnd_pic - (rnd_pic/pics_no)*pics_no;
    Show_Pic(rnd_pic);
    Free_PicsHeader();
    CloseFile(lf);    
    free(logoname);
    logoname = NULL;
}

int Lock_Init(struct event *e)
{
    return 0;
}

int Lock_Exit(struct event *e)
{
    return 0;
}

int Lock_Show(struct event *e)
{
    Lock_Paint();
    return 0;
}

int Lock_KeyPress(struct event *e)
{
    e->type = 0;
    return 0;
}

int Lock_KeyRelease(struct event *e)
{
    int key = e->par1;
    if (key==lock_key) CloseScreen();
    e->type = 0;
    return 0;
}

int Lock_KeyRepeat(struct event *e)
{
    e->type = 0;
    return 0;
}

static const struct evtproc lock_evtproc[] =
{
    { EVT_INIT, Lock_Init },
    { EVT_SHOW, Lock_Show },
    { EVT_KEYPRESS, Lock_KeyPress },
    { EVT_KEYRELEASE, Lock_KeyRelease },
    { EVT_KEYREPEAT, Lock_KeyRepeat },
    { EVT_EXIT, Lock_Exit },
    { 0,    NULL },
};

void Lock_Handler()
{
    struct event evt;
    GetNextEvent(&evt);
    HandleEvent(lock_evtproc, &evt);
    TranslateEvent(&evt);
}
