#include "lock.h"

extern int logocount, lf, pics_no;
extern char *logoname;

extern struct pic_struct {
  unsigned int offset;
  unsigned char name[44];
  unsigned char reserved[16];
} *pics[60];

void DrawLOGO()
{
    struct bitmap lock_pic, *tmp;
    tmp = (void *)0x601000;
    lock_pic = *tmp;
    lock_pic.size = lock_pic._0a;
    lock_pic.data = (void *)0x601020;
    DrawBitmap(EINK, 0, 0, &lock_pic);
}

void FilesCount()
{
    int ftype;
    char *p, *path, *buf;
    path = calloc(16);
    buf = calloc(32);    
    
    strcat(path, "b:\\System\\Logo\\");
    
    strcpy(buf, path);
    strcat(buf, "*.bi8"); 

    logocount=0;
    p = FindFirstFile(buf, &ftype, 0);
    while (p != NULL)
    {
        if (ftype == 0)
        {
            logocount++;
        }
        p = FindNextFile(&ftype, 0);
    }
    free(path);
    free(buf);    
    return;
}

int Open_FileNo(int file_no)
{
    int ftype, fcount=0;
    char *p, *path, *buf;
    path = calloc(16);
    buf = calloc(32);    
    
    strcat(path, "b:\\System\\Logo\\");
    
    memset(logoname, 0, 256);

    strcpy(buf, path);
    strcat(buf, "*.bi8"); 

    p = FindFirstFile(buf, &ftype, 0);
    while ((p != NULL)&&(fcount<file_no))
    {
        if (ftype == 0)
        {
            fcount++;
            if (fcount==file_no)
            {
                strcpy(logoname,path);
                strcat(logoname,p);
            }
        }
        p = FindNextFile(&ftype, 0);
    }

    free(path);
    free(buf);    
    return OpenFile(logoname);
}

void Load_PicsHeader()
{
    int size, i=0;
    unsigned char format_vers;
    
    ReadFile(lf, &format_vers, 1, &size);
    if (format_vers!=1)
    {
        CloseScreen();
        return;
    }
    
    unsigned char reserved[13];
    ReadFile(lf, &pics_no, sizeof(short int), &size);
    ReadFile(lf, &reserved, 13, &size);
    
    for (i=0;i<pics_no;i++)
    {
        pics[i] = calloc(sizeof(struct pic_struct));
        ReadFile(lf, pics[i], sizeof(struct pic_struct), &size);
        
        //tbd: try to avoid this workaround needed "/0" for %s
        pics[i]->name[44]=0;
    }
}

void Free_PicsHeader()
{
    int i;
    for (i=0;i<pics_no;i++)
    {
        free(pics[i]);
        pics[i] = NULL;
    }
    pics_no = 0;
}

void Show_Pic(int curr_pic)
{
    int size, x=0, y=0;
    struct bitmap tmp_pic;
    
    ClearWindow(EINK);

    SeekFile(lf, pics[curr_pic]->offset,SEEK_SET);
    ReadFile(lf, &tmp_pic, sizeof(struct bitmap), &size);
    x = (600 - tmp_pic.width)/2;
    y = (800 - tmp_pic.height)/2;
    
    SeekFile(lf, pics[curr_pic]->offset+16,SEEK_SET);
    if (tmp_pic.compressed==1)
    {
        char *picdata;
        picdata = calloc(tmp_pic.size);
        ReadFile(lf, picdata, tmp_pic.size, &size);
    
        tmp_pic.data = picdata;
        DrawBitmap(EINK, x, y, &tmp_pic);
        free(picdata);
        picdata = NULL;
    }
    else
    {
        struct window *W;
        W = WindowById(EINK);
        
        unsigned char *outbuf;
        outbuf = W->buffer;
        outbuf+= y*W->scanline + x/4;
        int i;
        for (i=0;i<tmp_pic.height;i++)
        {
            ReadFile(lf, outbuf, tmp_pic.scanline, &size);
            outbuf+=W->scanline;
        }
    }
}
