#include "er.h"
#include "cfg_common.h"

void TextOutCenter(int win, int x, int y, int w, int h, int aw, int ah, char *text)
{
    int dx=0, dy=0, tw=0, th=0, i=0, cw=0;
    char *cc;

    cc = text;
    th = GetFontHeight(curr_font->pointer);

    cc = calloc(128*sizeof(char));

    tw = GetStringWidth(text, curr_font->pointer);
    if (tw>w)
    {
        cw = GetCharWidth(133, curr_font->pointer);
        tw = 0;
        while (tw < w-cw)
        {
            *(cc+i)=*(text+i);
            tw = GetStringWidth(cc, curr_font->pointer);
            i++;
        }
        *(cc+i) = 133;
    }

    switch (aw)
    {
    case 0:
        dx = (w - tw)/2;
        break;
    case 1:
        dx = 0;
        break;
    case 2:
        dx = tw;
        break;
    }

    switch (ah)
    {
    case 0:
        dy = (h - th)/2;
        break;
    case 1:
        dy = 0;
        break;
    case 2:
        dy = th;
        break;
    }

    y += curr_font->ascent;
    if (i==0)
    {
        Print(win, x+dx, y+dy, text, curr_font->pointer);
    }
    else
    {
        Print(win, x+dx, y+dy, cc, curr_font->pointer);
    }

    free(cc);
    cc=NULL;
}

int TextOutMultiLines(int win, int x, int y, int w, char *text, int end)
{
    int tw=0, cw=0, i=0, offset=0, space=0;
    char *cc;

    cc = text;
    cc = calloc(128*sizeof(char));

    if (end)
    {
        tw = GetStringWidth(text, curr_font->pointer);
        if (tw>w)
        {
            cw = GetCharWidth(133, curr_font->pointer);
            tw = 0;
            while (tw < w-cw)
            {
                *(cc+i)=*(text+i);
                tw = GetStringWidth(cc, curr_font->pointer);
                i++;
            }
            *(cc+i) = 133;
        }
    }
    else
    {
        tw = GetStringWidth(text, curr_font->pointer);
        if (tw>w)
        {
            tw = 0;
            i = 0;
            while (tw < w)
            {
                *(cc+i)=*(text+i);
                tw = GetStringWidth(cc, curr_font->pointer);
                if (*(cc+i)==32) space++;
                offset++;
                i++;
            }
            if ((space!=0)&&((*(cc+i)!=32)||(*(cc+i+1)!=32)))
            {
                while (*(cc+i)!=32)
                {
                    *(cc+i) = 0;
                    i--;
                    offset--;
                }
            }
            // let's shift one step ahead to skip "space"
            offset++;
        }
    }

    y += curr_font->ascent;
    if (i==0)
    {
        Print(win, x, y, text, curr_font->pointer);
    }
    else
    {
        Print(win, x, y, cc, curr_font->pointer);
    }

    free(cc);
    cc=NULL;
    
    return offset;
}

void iprintf(char *text, int number)
{
    char buf[50];
    sprintf(buf,"%s%i", text, number);
    lprintf(buf);
}

void cprintf(char *text, char symbol)
{
    char buf[50];
    sprintf(buf,"%s%c", text, symbol);
    lprintf(buf);
}

void SetByte(unsigned char *dest, int nmbr, int val)
{
    if  (val == 1) *dest |= (1 << nmbr);
    if ((val == 0)&&((*dest&(1<<nmbr))>>nmbr)) *dest ^= (1 << nmbr);
}

int GetByte(unsigned char *source, int nmbr)
{
    return ((*source&(1<<nmbr))>>nmbr);
}

void RotateScreen()
{
    struct window *W;
    W = WindowById(EINK);

    unsigned char *win, cc1, cc2;
    unsigned char c1, c2, c3, c4;
    int buf_size, i;

    win = W->buffer;
    buf_size = (W->h-1)*W->scanline-((W->bwidth-W->w)/4-W->scanline)-1;
    for (i=0;i<buf_size/2;i++)
    {
        cc1 = *(win+i);
        c1 = ((cc1&192)>>6);
        c2 = ((cc1&48 )>>2);
        c3 = ((cc1&12 )<<2);
        c4 = ((cc1&3  )<<6);
        cc1 = c1+c2+c3+c4;

        cc2 = *(win+buf_size-i);
        c1 = ((cc2&192)>>6);
        c2 = ((cc2&48 )>>2);
        c3 = ((cc2&12 )<<2);
        c4 = ((cc2&3  )<<6);
        cc2 = c1+c2+c3+c4;

        *(win+i) = cc2;
        *(win+buf_size-i) = cc1;
    }
}

void SetLayout(int win, unsigned char layout)
{
    struct window *W = WindowById(win);
    if (W != NULL && W->layout != layout) SwitchLayout(win, layout);
}

int WordsComp(unsigned char *first, unsigned char *second)
{
    while (1)
    {
        if ((*first==0)||(*first==' ')||(*second==0)||(*second==' ')) return 1;
        if (*first!=*second) return 0;
        first++;
        second++;
    }
    return 1;
}

int DefineTag(unsigned char *cc, unsigned char *tag)
{
    unsigned char *temp;
    int count = 1, max_length = 16;

    temp = tag;
    cc++;
    while ((*cc!=' ')&&(*cc!='>')&&(count<=max_length))
    {
        *temp = *cc;
        cc++;
        temp++;
        count++;
    }
    while ((*cc!='>'))
    {
        cc++;
        count++;
    }
    return(count);
}

int DefineCode(unsigned char *cc, unsigned char *symb)
{
    unsigned char *temp, *code;
    int count = 1, max_length = 8;

    code = calloc(8);
    temp = code;
    cc++;
    while (*cc!=';')
    {
        *temp = *cc;
        cc++;
        temp++;
        count++;
        if (count>max_length)
        {
            count = 0;
            break;
        }
    }
    
    *symb = 0;
    // standard XML codes
    if (WordsComp(code, "lt"))    *symb = '<';
    if (WordsComp(code, "#60"))   *symb = '<';
    if (WordsComp(code, "#x3C"))  *symb = '<';

    if (WordsComp(code, "gt"))    *symb = '>';
    if (WordsComp(code, "#62"))   *symb = '>';
    if (WordsComp(code, "#x3E"))  *symb = '>';

    if (WordsComp(code, "amp"))   *symb = '&';
    if (WordsComp(code, "#38"))   *symb = '&';
    if (WordsComp(code, "#x26"))  *symb = '&';

    if (WordsComp(code, "quot"))  *symb = '\"';
    if (WordsComp(code, "#34"))   *symb = '\"';
    if (WordsComp(code, "#x22"))  *symb = '\"';

    if (WordsComp(code, "apos"))  *symb = '\'';
    if (WordsComp(code, "#39"))   *symb = '\'';
    if (WordsComp(code, "#x27"))  *symb = '\'';
    
    // some codes that I have met
    if (WordsComp(code, "#8209")) *symb = '-';

    if (WordsComp(code, "euro"))  *symb = '';
    if (WordsComp(code, "#8364")) *symb = '';

    if (WordsComp(code, "curren"))*symb = '';
    if (WordsComp(code, "#164"))  *symb = '';

    if (WordsComp(code, "sect"))  *symb = '';
    if (WordsComp(code, "#167"))  *symb = '';

    if (WordsComp(code, "copy"))  *symb = '';
    if (WordsComp(code, "#169"))  *symb = '';

    if (WordsComp(code, "reg"))   *symb = '';
    if (WordsComp(code, "#174"))  *symb = '';

    if (WordsComp(code, "laquo")) *symb = '';
    if (WordsComp(code, "#171"))  *symb = '';

    if (WordsComp(code, "raquo")) *symb = '';
    if (WordsComp(code, "#187"))  *symb = '';

    if (WordsComp(code, "lsquo")) *symb = '';
    if (WordsComp(code, "#8216")) *symb = '';

    if (WordsComp(code, "rsquo")) *symb = '';
    if (WordsComp(code, "#8217")) *symb = '';

    if (WordsComp(code, "sbquo")) *symb = '';
    if (WordsComp(code, "#8218")) *symb = '';

    if (WordsComp(code, "ldquo")) *symb = '';
    if (WordsComp(code, "#8220")) *symb = '';

    if (WordsComp(code, "rdquo")) *symb = '';
    if (WordsComp(code, "#8221")) *symb = '';

    if (WordsComp(code, "bdquo")) *symb = '';
    if (WordsComp(code, "#8222")) *symb = '';

    if (WordsComp(code, "ndash")) *symb = '';
    if (WordsComp(code, "#8211")) *symb = '';

    if (WordsComp(code, "mdash")) *symb = '';
    if (WordsComp(code, "#8212")) *symb = '';

    if (WordsComp(code, "hellip"))*symb = '';
    if (WordsComp(code, "#8230")) *symb = '';

    if (WordsComp(code, "bull"))  *symb = '';
    if (WordsComp(code, "#8226")) *symb = '';

    if (WordsComp(code, "trade")) *symb = '';
    if (WordsComp(code, "#8482")) *symb = '';
    
    if (WordsComp(code, "acute")) *symb = '`';
    if (WordsComp(code, "#180"))  *symb = '`';
    
    if (WordsComp(code, "para"))  *symb = '';
    if (WordsComp(code, "#182"))  *symb = '';
    
    if (WordsComp(code, "plusmn"))*symb = '';
    if (WordsComp(code, "#177"))  *symb = '';
        
    if (WordsComp(code, "permil"))*symb = '';
    if (WordsComp(code, "#8240")) *symb = '';
    
    if (WordsComp(code, "tilde")) *symb = '~';
    if (WordsComp(code, "#732"))  *symb = '~';
    
    if (WordsComp(code, "deg"))   *symb = '';
    if (WordsComp(code, "#176"))  *symb = '';
    
    if (WordsComp(code, "not"))   *symb = '';
    if (WordsComp(code, "#172"))  *symb = '';
    
    // there are many other symbols, if they are not in my list - let's show just ?-sign
    if (*symb==0) *symb = '?';
    
    free(code);
    return(count);
}

void DrawHBattary(int win, int x, int y)
{
    int i, pow;

    i = GetSysState();
    if ((i&0x0001)==1)
    {
        DrawImageResource(win, x, y, "BAT_H_XX");
    }
    else
    {
        pow = *GetBatteryPower();

        if (pow <= 2)
            DrawImageResource(win, x, y, "BAT_H_00");
        else if ((pow > 2)&&(pow <= 5))
            DrawImageResource(win, x, y, "BAT_H_05");
        else if ((pow > 5)&&(pow <= 10))
            DrawImageResource(win, x, y, "BAT_H_10");
        else if ((pow > 10)&&(pow <= 20))
            DrawImageResource(win, x, y, "BAT_H_20");
        else if ((pow > 20)&&(pow <= 30))
            DrawImageResource(win, x, y, "BAT_H_30");
        else if ((pow > 30)&&(pow <= 40))
            DrawImageResource(win, x, y, "BAT_H_40");
        else if ((pow > 40)&&(pow <= 50))
            DrawImageResource(win, x, y, "BAT_H_50");
        else if ((pow > 50)&&(pow <= 60))
            DrawImageResource(win, x, y, "BAT_H_60");
        else if ((pow > 60)&&(pow <= 70))
            DrawImageResource(win, x, y, "BAT_H_70");
        else if ((pow > 70)&&(pow <= 80))
            DrawImageResource(win, x, y, "BAT_H_80");
        else if ((pow > 80)&&(pow <= 90))
            DrawImageResource(win, x, y, "BAT_H_90");
        else if ((pow > 90)&&(pow <= 100))
            DrawImageResource(win, x, y, "BAT_H_99");
    }
}

void DrawVBattary(int win, int x, int y)
{
    int i, pow;

    i = GetSysState();
    if ((i&0x0001)==1)
    {
        DrawImageResource(win, x, y, "BAT_V_XX");
    }
    else
    {
        pow = *GetBatteryPower();

        if (pow <= 2)
            DrawImageResource(win, x, y, "BAT_V_00");
        else if ((pow > 2)&&(pow <= 5))
            DrawImageResource(win, x, y, "BAT_V_05");
        else if ((pow > 5)&&(pow <= 10))
            DrawImageResource(win, x, y, "BAT_V_10");
        else if ((pow > 10)&&(pow <= 20))
            DrawImageResource(win, x, y, "BAT_V_20");
        else if ((pow > 20)&&(pow <= 30))
            DrawImageResource(win, x, y, "BAT_V_30");
        else if ((pow > 30)&&(pow <= 40))
            DrawImageResource(win, x, y, "BAT_V_40");
        else if ((pow > 40)&&(pow <= 50))
            DrawImageResource(win, x, y, "BAT_V_50");
        else if ((pow > 50)&&(pow <= 60))
            DrawImageResource(win, x, y, "BAT_V_60");
        else if ((pow > 60)&&(pow <= 70))
            DrawImageResource(win, x, y, "BAT_V_70");
        else if ((pow > 70)&&(pow <= 80))
            DrawImageResource(win, x, y, "BAT_V_80");
        else if ((pow > 80)&&(pow <= 90))
            DrawImageResource(win, x, y, "BAT_V_90");
        else if ((pow > 90)&&(pow <= 100))
            DrawImageResource(win, x, y, "BAT_V_99");
    }
}
